
/* 

  Modified by :
          Gary F. Desrochers (garyd@slate.mines.colorado.edu)
          Sean Kerstiens     (skerstie@slate.mines.colorado.edu)

  Created For:
          Colorado School of Mines.

  Last edited: 
          June 22,1992

*/
// This was obtained from NextDevelopers examples.
// The following header was kept for completness.
/*
        CommandScroll.m
	by Joe Freeman
        Subprocess Example, Release 2.0
        NeXT Computer, Inc.

	You may freely copy, distribute and reuse the code in this example.
	NeXT disclaims any warranty of any kind, expressed or implied, as to
	its fitness for any particular use.
*/
// This file was edited by Gary F.Desrochers and Sean Kerstiens.
// at Colorado School of Mines to create logo for the NeXT.

#import <appkit/ScrollView.h>

/*
 * This object sends its delegate the "userEntered:" message
 * whenever new text is entered in the text object inside this ScrollView
 *
 */

// For purposes of this logo program the delegate is the Controller class.
 
@interface CommandScroll:ScrollView
{
    // The docView is the Text object within the View.
    id	docView;
    // The delagate is the Controller class.
    id	delegate;
    // Size of the text object the last time this program played with it
    int lastTextCount;
    // So the user can distinguish what they typed from system output
    // machineFont is the output font.
    // userFont is the font for the typed input.
    id	machineFont, userFont;
    // The sameLine is used by the backspace and some other things to tell
    // if the same line is being edited.
    BOOL sameLine;
}

- appendString:(char *)buffer;
    // append the buffer to the end of the text object

@end
