/* 
  This class was created to control all portions of the graphical interface
  from within logo for the NeXT.  The old logo code only has the id of
  Controller.m

  Created by :
          Gary F. Desrochers (garyd@slate.mines.colorado.edu)
          Sean Kerstiens     (skerstie@slate.mines.colorado.edu)

  Created For:
          Colorado School of Mines.

  Last edited: 
          June 22,1992

*/
#import <objc/Object.h>
#define IPBUFSIZE 10240

@interface Controller:Object
{
    //  The id for the Text input and output.
    id	idErrorOut;
    //  The id for the DrawView.
    id	idDrawing;
    //  The id for the quit button in the menu.
    id  idQuit;
    //  The Memory Stream passed to the getchar used by the lexical analizer.
    NXStream *aStream;
    //  The buffer for stdout.
    char tbuff[IPBUFSIZE];

}

+new;
- sendString:(char *)cBuffer;
- initialize;
- drawTurtle:(int)hide: (double)angle :(double)tox :(double)toy;
- drawLine:(double)type :(double)fromx :(double)fromy :(double)tox: (double)toy;
- clearScreen;
- flush;
- printRequest:sender;

// CommandScroll Delegation

- userEntered:(char *)buffer;

@end
