/* 
  This class was created to control the drawing from within logo for the NeXT.

  Created by :
          Gary F. Desrochers (garyd@slate.mines.colorado.edu)
          Sean Kerstiens     (skerstie@slate.mines.colorado.edu)

  Created For:
          Colorado School of Mines.

  Last edited: 
          June 22,1992

*/
#import <appkit/View.h>
#import <streams/streams.h>
#import <dpsclient/dpsNeXT.h>
#import <sys/param.h>
#import <appkit/defaults.h>
#import <string.h>
#import <dpsclient/dpsclient.h>
@interface DrawView:View
{
    //  The turtle NXImage id.
    id idTurtle;
    //  The background NXImage id.
    id idBackground;
    //  Tells whether or not to composite the Turtle.
    BOOL drawTurtle;
    //  Sturct for the linked list.
    struct prStruct {
           float oArray[4];
	   char  cArray[4];
	   struct prStruct *nextStruct;
	   }firstStruct;
    //  This holds the present position of where in the link list you are at.
    struct prStruct *thisStruct;
    //  This is used for the DPS stuff.  Just the bounds of the picture.
    float  bbox[4];
    NXRect sRect, rRect;
    char *name;
    double turtleAngle;
}

- initFrame:(const NXRect *)tF;
- drawTurtleWith:(double)angle :(double)tox :(double)toy :(int)hide;
- drawSelf:(NXRect *)r :(int)count;
- drawLine:(double)type :(double)fromx :(double)fromy :(double)tox: (double)toy;
- clearScreen;
- print;

/* target action messages sent menu items */
- save:sender;
- saveAs:sender;
- saveTo:sender;
- open:sender;
- add:sender;
- new:sender;
@end
 
