/* Copyright  1991 Gustavus Adolphus College.  All rights reserved.
 *
 * Schematik was developed by Gustavus Adolphus College (GAC) with
 * support from NeXT Computer, Inc.  Permission to copy this software,
 * to redistribute it, and to use it for any purpose is granted,
 * subject to the following restrictions and understandings.
 *
 * 1. Any copy made of this software must include this copyright
 * notice in full.
 *
 * 2. Users of this software agree to make their best efforts (a) to
 * return to the GAC Mathematics and Computer Science Department any
 * improvements or extensions that they make, so that these may be
 * included in future releases; and (b) to inform GAC of noteworthy
 * uses of this software.
 *
 * 3. All materials developed as a consequence of the use of this
 * software shall duly acknowledge such use, in accordance with the
 * usual standards of acknowledging credit in academic research.
 *
 * 4. GAC makes no express or implied warranty or representation of
 * any kind with respect to this software, including any warranty
 * that the operation of this software will be error-free.  ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR
 * PURPOSE IS HEREBY DISCLAIMED.  GAC is under no obligation to
 * provide any services, by way of maintenance, update, or otherwise.
 *
 * 5. In conjunction with products arising from the use of this
 * material, there shall be no use of the name of Gustavus Adolphus
 * College nor of any adaptation thereof in any advertising,
 * promotional, or sales literature without prior written consent
 * from GAC in each case.
 */

#import <appkit/Application.h>

@interface Main:Application
{
    id	findAgent;
    id	helpAgent;
    id	infoAgent;
    id	interactionWindow;
    id	prefAgent;
    id	protocolObj;
    id	graphicsViews;
NXZone	*graphicsZone;
}

- info:sender;
- help:sender;
- manual:sender;
- preferences:sender;
- newDocument:sender;
- openDocument:sender;
- find:sender;
- findNext:sender;
- findPrevious:sender;
- evaluate:sender;
- abort:sender;
- print:sender;

- (id)findAgent;
- (id)helpAgent;
- (id)prefAgent;
- (id)infoAgent;
- (id)interactionWindow;
- (id)protocolObj;

- openGraphicsWindow:(unsigned)windowNum width:(unsigned)width height:(unsigned)height;
- closeGraphicsWindow:(unsigned)windowNum;
- setGraphicsWindowFlush:(unsigned)windowNum mode:(unsigned)mode;
- printGraphicsWindow:(unsigned)windowNum;

@end

@interface Main (Subclass)
- restartSubprocess;
@end

#import <appkit/FontPanel.h>

@interface MyFontPanel:FontPanel

+ newContent:(const NXRect *)contentRect style:(int)aStyle backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;

@end

#import <appkit/Window.h>

@interface Window (PrintingExt)

- print:sender;

@end

#import <appkit/View.h>

@interface View (PrintingExt)

- (BOOL)hasSubviewOfKind:aClass;

@end
