-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
expanded class FILE_TOOLS

inherit ANY
   redefine same_files
      end;

feature

   same_files(path1, path2: STRING): BOOLEAN is
	 -- True if `path1' file exists and as the 
	 -- same contents as file `path2'.
      require
	 path1 /= Void;
	 path2 /= Void;
      do
	 if not file_exists(path1) then
	 elseif not file_exists(path2) then
	 else
	    std_fr1.connect_to(path1);
	    std_fr2.connect_to(path2);
	    if not std_fr1.is_connected then
	    elseif not std_fr1.is_connected then
	    else
	       from
		  Result := true;
	       until
		  not Result or else
		  std_fr1.end_of_input or else
		  std_fr2.end_of_input 
	       loop
		  std_fr1.read_character;
		  std_fr2.read_character;
		  Result := std_fr1.last_character = std_fr2.last_character;
	       end
	       std_fr1.disconnect;
	       std_fr2.disconnect;
	    end;
	 end;
      end;

   is_empty(path: STRING): BOOLEAN is
	 -- True if `path' file exists, is readable and is an 
	 -- empty file.
      do
	 if file_exists(path) then
	    std_fr1.connect_to(path);
	    if std_fr1.is_connected then
	       std_fr1.read_character;
	       Result := std_fr1.end_of_input;
	       std_fr1.disconnect;
	    end;
	 end;
      end;

feature {NONE}

   std_fr1: STD_FILE_READ is
      once
	 !!Result.make;
      end;

   std_fr2: STD_FILE_READ is
      once
	 !!Result.make;
      end;

end -- FILE_TOOLS
