-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class STD_OUTPUT
--
-- To use the standard output file. As for UNIX, the default standard 
-- output is the screen.
--
-- Notes: - the predefined `std_output' should be use to have only one instance 
--        of the class STD_OUTPUT,
--        - to do reading or writing at the same time on the screen, 
--        see STD_INPUT_OUTPUT,
--        - to handle cursor of the screen, see CURSES.
--
   
inherit STD_FILE_WRITE redefine disconnect end;
   
creation 
   make, connect_to
   
feature {ANY}
   
   make is
      do
	 output_stream := stdout;
      ensure
	 not is_connected
      end;
      
   disconnect is
      local
	 err: INTEGER;
      do
	 err := fclose(output_stream); 
	 path := Void;
	 output_stream := stdout;
      end;
      
feature {RUN_FEATURE}   
   
   stdout: POINTER is
      external "CSE"
      end;

end -- STD_OUTPUT
