-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_ARRAY_RESIZE

creation {ANY}
   make
   
feature {ANY}
   
   ti1, ti2: ARRAY[INTEGER];
   tc1, tc2: ARRAY[CAT];
		
   c1, c2, c3, c4, c5, c6: CAT;

   make is
      do
	 ti1 := <<1,2,3,4,5,6,7,8,9>>;
	 ti2 := <<1,2,3,4,5,6,7,8,9>>;
	 ti1.resize(2,9);
	 is_true(ti1.is_equal(ti2.sub_array(2,9)));
	 ti1.resize(2,8);
	 is_true(ti1.is_equal(ti2.sub_array(2,8)));
	 ti1.resize(3,7);
	 is_true(ti1.is_equal(ti2.sub_array(3,7)));
	 ti1.resize(1,9);
	 is_true(ti1.is_equal(<<0,0,3,4,5,6,7,0,0>>));
	 ti1.resize(1,10);
	 is_true(ti1.is_equal(<<0,0,3,4,5,6,7,0,0,0>>));
	 ti1.make(1,9);
	 is_true(ti1.is_equal(<<0,0,0,0,0,0,0,0,0>>));
	 
	 !!c1;
	 !!c2;
	 !!c3;
	 !!c4;
	 !!c5;
	 !!c6;
	 
	 tc1 := <<c1,c2,c3,c4,c5,c6>>;
	 tc2 := <<c1,c2,c3,c4,c5,c6>>;
	 tc1.resize(2,6);
	 is_true(tc1.is_equal(tc2.sub_array(2,6)));
	 tc1.resize(2,5);
	 is_true(tc1.is_equal(tc2.sub_array(2,5)));
	 tc1.resize(3,4);
	 is_true(tc1.is_equal(tc2.sub_array(3,4)));
	 tc1.resize(1,6);
	 is_true(tc1.is_equal(<<Void,Void,c3,c4,Void,Void>>));
	 tc1.resize(1,7);
	 is_true(tc1.is_equal(<<Void,Void,c3,c4,Void,Void,Void>>));
	 tc1.make(1,6);
	 tc2.clear_all;
	 is_true(tc1.is_equal(tc2));
      
      end;
   
   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_ARRAY_RESIZE: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end -- TEST_ARRAY_RESIZE
