-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_IRF3
-- Test inlining of RUN_FEATURE3.

creation make
   
feature 
   
   att: INTEGER;

   make is
      do
	 set_attribute1(1 + 1);
	 set_attribute2;
	 set_attribute3;
	 set_attribute4;
	 set_attribute5;
	 inline1;
	 inline2;
	 inline3;
	 inline4;
      end;

feature {NONE} -- All those feature are inlined in -boost mode :

   set_attribute1(a: like att) is
      do
	 att := a;
      end;

   set_attribute2 is
      do
	 att := 4;
      end;
      
   set_attribute3 is
      local
	 i: INTEGER;
      do
	 att := i;
      end;
   
   set_attribute4 is
      local
	 i: INTEGER;
	 j: INTEGER;
      do
	 att := i;
      end;

   set_attribute5 is
      local
	 i: INTEGER;
	 j: INTEGER;
      do
	 att := i + j;
      end;

   inline1 is
      local
	 i: INTEGER;
	 j: INTEGER;
      do
      end;

   inline2 is
      local
	 i: INTEGER;
	 j: INTEGER;
      do
	 i := 1;
	 j := i + 1;
      end;

   inline3 is
      do
	 inline1;
	 inline2;
      end;

feature {NONE} -- Recursive call is not inlined :-) 

   inline4 is
      local
	 i: INTEGER;
      do
	 i := i + 1;
	 if i < 0 then
	    inline4;
	 end;
      end;

feature {NONE}

   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_INTEGER1: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end -- TEST_IRF3

