-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_IS_EXPANDED_TYPE

creation {ANY}
   make
   
feature {ANY}
   
   make is
      local
	 i: INTEGER;
	 r: REAL;
	 d: DOUBLE;
	 c: CHARACTER;
	 b: BOOLEAN;
	 p: POINT;
	 aexp: ARRAY[INTEGER];
	 aref: ARRAY[POINT];
	 cp: COLORED_POINT;
	 t_string: AUX_IS_EXPANDED_TYPE[STRING];
	 t_integer: AUX_IS_EXPANDED_TYPE[INTEGER];
      do
	 is_true(('a').is_expanded_type);
	 is_true((true).is_expanded_type);
	 is_true((false).is_expanded_type);
	 is_true((1.5).is_expanded_type);
	 is_true((1).is_expanded_type);
	 
	 is_true(i.is_expanded_type);
	 is_true(r.is_expanded_type);
	 is_true(d.is_expanded_type);
	 is_true(c.is_expanded_type);
	 is_true(b.is_expanded_type);
	 
	 !!p.make(1,2);
	 is_true(not p.is_expanded_type);
	 is_true(not clone(p).is_expanded_type);
	 
	 !!aref.make(1,1);
	 is_true(aexp.item(1).is_expanded_type);
	 is_true(not aref.item(1).is_expanded_type);
      
	 p := cp;
	 is_true(not p.is_expanded_type);
	 is_true(not cp.is_expanded_type);
	 
	 is_true(not t_string.item.is_expanded_type);
	 is_true(t_integer.item.is_expanded_type);

	 if t_integer.item.is_expanded_type then
	 else
	    is_true(false);
	 end;

	 if t_string.item.is_expanded_type then
	    is_true(false);
	 end;
      end;
   
   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_IS_EXPANDED_TYPE: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end -- TEST_IS_EXPANDED_TYPE
