Changes file for /usr/local/src/kcl/cmpnew/cmplam.lsp
Created on Tue Jul  9 17:25:06 1991
Usage \n@s[Original text\n@s|Replacement Text\n@s]
See the file rascal.ics.utexas.edu:/usr2/ftp/merge.c
for a program to merge change files.  Anything not between
"\n@s[" and  "\n@s]" is a simply a comment.
This file was constructed using emacs and  merge.el
Enhancements Copyright (c) W. Schelter All rights reserved.
   by (Bill Schelter)  wfs@carl.ma.utexas.edu 


****Change:(orig (51 51 a))
@s[           (cmperr "The lambda list ~s is illegal." vl)))


@s|           (cmperr "The lambda list ~s is illegal." vl)))


;;;the following code implements downward closures.
;;;These are like closures, except they are guaranteed not
;;;to survive past the exit of the function in which they
;;;are born.


(defmacro downward-function (x)
  `(function ,x))

(setf (get 'downward-function  'c1special)
      'c1downward-function)

(defun c1downward-function (x)
  (let* ((tem (c1expr (list 'function (car x))))
	 (info (cadr tem)))
    ;; for the moment we only allow downward closures with no args
    (cond ((and (consp x) (consp (car x))
		(eq (caar x) 'lambda)
		(null (second (car x))))
	   (dolist (var (info-referred-vars info))
		   (cond ((and (eq (var-kind var) 'lexical)
			       (var-ref-ccb var) t)
			  (setf (var-kind var) 'down)))
		   )
	   (setf (car tem) 'downward-function)
	   tem)
	  (t tem))))

(si::putprop   'downward-function  'c2downward-function  'c2)
(si:putprop 'make-dclosure 'wt-make-dclosure 'wt-loc)

(defun wt-make-dclosure (cfun clink)clink  ;;Dbase=base0
  (wt-nl "(DownClose"cfun".t=t_dclosure,DownClose" cfun ".dc_self=LC" cfun","
     "DownClose" cfun ".dc_env=base0,(object)&DownClose" cfun ")"))

(defun wfs-error ()
  (error "This error is not supposed to occur: Contact Schelter ~
    ~%wfs@math.utexas.edu"))

(defun wt-downward-closure-macro (cfun)
  (cond (*downward-closures*
	  (wt-h "#define DCnames" cfun " ")
	  (setq *downward-closures* (delete 'dcnames *downward-closures*))
	  (cond (*downward-closures*
		  (wt-h1 "struct dclosure ")
		  (do ((v *downward-closures* (cdr v)))
		      ((null v))
		      (wt-h1 "DownClose")
		      (wt-h1 (car v))
		      (if (cdr v) (wt-h1 ",")))
		  (wt-h1 ";"))))))

(defun c2downward-function (funob)
  (let ((fun (make-fun :name 'closure :cfun (next-cfun))))
              (push (list 'dclosure (if (null *clink*) nil (cons 0 0))
                          *ccb-vs* fun funob)
                    *local-funs*)
              (push fun *closures*)
	      (push (fun-cfun fun) *downward-closures*)
              (unwind-exit (list 'make-dclosure (fun-cfun fun) *clink*))))




@s]


****Change:(orig (55 55 a))
@s[                           (keywords nil) (key-flag nil)

@s|                           (keywords nil) (key-flag nil)
			   lambda-list

@s]


****Change:(orig (61 61 a))
@s[                           (aux-info nil)

@s|                           (aux-info nil)
			   (setjmps *setjmps*)

@s]


****Change:(orig (68 68 c))
@s[                       (c1body (cdr lambda-expr) t))


@s|                       (c1body (cdr lambda-expr) t))
  

@s]


****Change:(orig (253 253 c))
@s[  (dolist** (var aux-vars) (check-vref var))


@s|  (dolist** (var aux-vars) (check-vref var))
  

@s]


****Change:(orig (256 257 c))
@s[        (setq body (list 'let* aux-info aux-vars aux-inits body)))


@s|        (setq body (list 'let* aux-info aux-vars aux-inits body))
	(or (eql setjmps *setjmps*) (setf (info-volatile aux-info) t)))
  
  (setq body (fix-down-args requireds body block-name))
  (setq lambda-list
	(list requireds optionals rest key-flag keywords allow-other-keys))
  (and *record-call-info* (record-arg-info lambda-list))

@s]


****Change:(orig (260 260 c))
@s[        (list requireds optionals rest key-flag keywords allow-other-keys)

@s|	lambda-list

@s]


****Change:(orig (264 264 a))
@s[        doc
        body)
  )


@s|        doc
        body)
  )


;;this makes a let for REQUIREDS which are used in a downward 
;;lexical closure

(defun fix-down-args(requireds body name &aux auxv auxinit info v)
  (let ((types	 (get  name 'proclaimed-arg-types))
	(fixed (get name 'fixed-args)))
    (do ((vv requireds (cdr vv))
	 (typ types (cdr typ)))
	((null vv))
	(setq v (car vv))
	(cond ((not (or fixed (eq (car typ) t)))
	       (return-from fix-down-args body))
	      ((and (eq (var-kind v) 'DOWN) (eq (var-loc v) 'object))
	       ;;a downward variable could not have been special
	       ;;and must be type t.  We create a new variable
	       ;;for the arg, and bind the old one to it.
	       (let* ((new (c1make-var (var-name v) nil nil nil))
		      (init
		       (list 'var 
			     (or info (setq info (make-info)))
			     (list new nil))))
		 (push  v auxv)
		 (setf (car vv) new)
		 (push new (info-referred-vars info))
		 (push init auxinit)))))
    (if auxv (list 'let* info auxv auxinit body)
      body)))


@s]


****Change:(orig (270 270 a))
@s[  (cmpck (constantp name) "The constant ~s is being bound." name)
  name
  )


@s|  (cmpck (constantp name) "The constant ~s is being bound." name)
  name
  )

(defvar *rest-on-stack* nil)  ;; non nil means put rest arg on C stack.


@s]


****Change:(orig (282 282 a))
@s[             (cons fname (car lambda-list))
             nil)))

@s|             (cons fname (car lambda-list))
             nil)))
    (let ((*rest-on-stack*
	    (cond ((and (caddr lambda-list)
			(eq (var-type (caddr lambda-list)) :dynamic-extent))
		   t)
		  (t *rest-on-stack*))))

@s]


****Change:(orig (286 286 c))
@s[           (c2lambda-expr-without-key lambda-list body)))
  )

@s|           (c2lambda-expr-without-key lambda-list body)))
  ))

@s]


****Change:(orig (310 310 c))
@s[                           (wt (rep-type kind) "V" cvar ";"))))))

@s|			   (wt-var-decl var)
			   )))))

@s]


****Change:(orig (347 347 a))
@s[               (*ccb-vs* *ccb-vs*))

@s|               (*ccb-vs* *ccb-vs*))
           (when rest
             (wt-nl "vs_top[0]=Cnil;")
             (wt-nl "{object *p=vs_top, *q=vs_base+" (length optionals) ";")
             (wt-nl " for(;p>q;p--)p[-1]=MMcons(p[-1],p[0]);}"))

@s]


****Change:(orig (357 357 c))
@s[             (when (or (cdr opts) rest) (wt-nl "vs_base++;"))

@s|             (when  (cdr opts)  (wt-nl "vs_base++;"))

@s]


****Change:(orig (359 364 c))
@s[
           (when rest
             (wt-nl "vs_top[0]=Cnil;")
             (wt-nl "{object *p=vs_top;")

@s,             (c2bind rest))

@s|           (when rest (c2bind rest))

@s]


****Change:(orig (387 387 c))
@s[         (wt-nl " for(;p>vs_base;p--)p[-1]=MMcons(p[-1],p[0]);}")

@s|         (wt-nl " for(;p>vs_base;p--)p[-1]="
		(if *rest-on-stack* "ON_STACK_CONS" "MMcons")
		"(p[-1],p[0]);}")

@s]


****Change:(orig (428 428 c))
@s[                           (wt (rep-type kind) "V" cvar ";"))))))

@s|			   (wt-var-decl var)
			   )))))

@s]


****Change:(orig (578 578 a))
@s[(defvar *dm-info*)
(defvar *dm-vars*)


@s|(defvar *dm-info*)
(defvar *dm-vars*)



@s]


****Change:(orig (580 580 a))
@s[                        &aux (*vs* *vs*) (whole nil) (env nil)

@s|                        &aux (*vs* *vs*) (whole nil) (env nil)
	(setjmps *setjmps*)

@s]


****Change:(orig (596 601 c))
@s[  (when (and (listp vl) (eq (car vl) '&environment))
        (push (cadr vl) *vnames*)
        (setq env (c1make-var (cadr vl) ss is ts))
        (push env *dm-vars*)

@s,        (setq vl (cddr vl)))

@s|  (let ((env-m (and (listp vl) (do ((tail vl (cdr tail)))
				   ((not (consp tail)) nil)
				 (when (eq '&environment (car tail))
				   (return tail))))))
    (when env-m
      (push (cadr env-m) *vnames*)
      (setq env (c1make-var (cadr env-m) ss is ts))
      (push env *dm-vars*)
      (push env *vars*)
      (setq vl (append (ldiff vl env-m) (cddr env-m)))))

@s]


****Change:(orig (606 606 a))
@s[  (add-info *dm-info* (cadr body))

@s|  (add-info *dm-info* (cadr body))
   (cond ((eql setjmps *setjmps*))
         (t(setf (info-volatile *dm-info*) t)
           (setf (get macro-name 'contains-setjmp) t)
               ))

@s]


****Change:(orig (608 609 c))
@s[
  (list doc ppn whole env vl body)

@s|  (list doc ppn whole env vl body *dm-info*)

@s]

