#include "../h/include.h"

static object fasl_data;

init_init()
{
	enter_mark_origin(&fasl_data);
	fasl_data = Cnil;

	load("../lsp/export.lsp");
	fasl_data = read_fasl_data("../lsp/defmacro.o");
	init_defmacro(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/evalmacros.o");
	init_evalmacros(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/top.o");
	init_top(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/module.o");
	init_module(NULL, 0, fasl_data);
	load("../lsp/autoload.lsp");
}

init_system()
{
	printf("Initializing predlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/predlib.o");
	init_predlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing setf...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/setf.o");
	init_setf(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing arraylib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/arraylib.o");
	init_arraylib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing assert...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/assert.o");
	init_assert(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing defstruct...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/defstruct.o");
	init_defstruct(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing describe...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/describe.o");
	init_describe(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing iolib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/iolib.o");
	init_iolib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing listlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/listlib.o");
	init_listlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing mislib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/mislib.o");
	init_mislib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing numlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/numlib.o");
	init_numlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing packlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/packlib.o");
	init_packlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing seq...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/seq.o");
	init_seq(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing seqlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/seqlib.o");
	init_seqlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing trace...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/trace.o");
	init_trace(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);

	printf("Initializing cmpinline...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpinline.o");
	init_cmpinline(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmputil...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmputil.o");
	init_cmputil(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmptype...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmptype.o");
	init_cmptype(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpbind...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpbind.o");
	init_cmpbind(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpblock...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpblock.o");
	init_cmpblock(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpcall...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpcall.o");
	init_cmpcall(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpcatch...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpcatch.o");
	init_cmpcatch(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpenv...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpenv.o");
	init_cmpenv(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpeval...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpeval.o");
	init_cmpeval(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpflet...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpflet.o");
	init_cmpflet(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpfun...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpfun.o");
	init_cmpfun(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpif...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpif.o");
	init_cmpif(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmplabel...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmplabel.o");
	init_cmplabel(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmplam...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmplam.o");
	init_cmplam(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmplet...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmplet.o");
	init_cmplet(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmploc...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmploc.o");
	init_cmploc(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpmap...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpmap.o");
	init_cmpmap(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpmulti...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpmulti.o");
	init_cmpmulti(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpspecial...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpspecial.o");
	init_cmpspecial(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmptag...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmptag.o");
	init_cmptag(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmptop...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmptop.o");
	init_cmptop(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpvar...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpvar.o");
	init_cmpvar(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpvs...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpvs.o");
	init_cmpvs(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing cmpwt...  ");  fflush(stdout);
	Vpackage->s.s_dbind = user_package;
	fasl_data = read_fasl_data("../cmpnew/cmpwt.o");
	init_cmpwt(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);

	Vpackage->s.s_dbind = user_package;
}
