#include "../h/include.h"

static object fasl_data;

init_init()
{
	enter_mark_origin(&fasl_data);
	fasl_data = Cnil;

	load("../lsp/export.lsp");
	fasl_data = read_fasl_data("../lsp/defmacro.o");
	init_defmacro(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/evalmacros.o");
	init_evalmacros(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/top.o");
	init_top(NULL, 0, fasl_data);
	fasl_data = read_fasl_data("../lsp/module.o");
	init_module(NULL, 0, fasl_data);
	load("../lsp/autoload.lsp");
}

init_system()
{
	printf("Initializing predlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/predlib.o");
	init_predlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing setf...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/setf.o");
	init_setf(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing arraylib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/arraylib.o");
	init_arraylib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing assert...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/assert.o");
	init_assert(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing defstruct...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/defstruct.o");
	init_defstruct(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing describe...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/describe.o");
	init_describe(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing iolib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/iolib.o");
	init_iolib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing listlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/listlib.o");
	init_listlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing mislib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/mislib.o");
	init_mislib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing numlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/numlib.o");
	init_numlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing packlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/packlib.o");
	init_packlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing seq...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/seq.o");
	init_seq(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing seqlib...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/seqlib.o");
	init_seqlib(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);
	printf("Initializing trace...  ");  fflush(stdout);
	fasl_data = read_fasl_data("../lsp/trace.o");
	init_trace(NULL, 0, fasl_data);
	printf("\n");  fflush(stdout);

	Vpackage->s.s_dbind = user_package;
}
