--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

	description: "MIME RFC1341 RTF Eiffel class formatter";
	date: "$Date: 1996/07/03 23:04:45 $";
	revision: "$Revision: 1.1 $";
 	original_author: "$Neil Wilson $";
	modified_by: "$Valentino Kyriakides$"

class MIME_FORMAT

inherit
	
	ASCII_FORMAT
		redefine
			bold_off,
			bold_on,
			write,
			italic_off,
			italic_on,
			next_line
		end

creation 

	make
	
feature {NONE} -- indent implementations
	
	bold_on is
			-- Output Bold start	
		do
			io.put_string ("<bold>")
		end; -- bold_on
	
	bold_off is
			-- Output Bold finish	
		do
			io.put_string ("</bold>")
		end; -- bold_off
	
	italic_on is
			-- Output Italic start	
		do
			io.put_string ("<italic>")
		end; -- italic_on
	
	italic_off is
			-- Output Italic end	
		do
			io.put_string ("</italic>")
		end; -- italic_off
	
	next_line is
			-- Output Newline
	do
		io.put_string("<nl>%N");
	end; -- next_line
	
	
feature {NONE} -- output manipulators
	
	write (s: STRING) is
			-- Place 's' on the output medium
			-- Post processing for reserved characters
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > s.count
			loop
				inspect s.item (i)
				when '<' then
					io.put_string ("<lt>")
				else
					io.put_character (s.item (i))
				end;
				i := i + 1
			end
		end; -- write
	
end -- class MIME_FORMAT
