--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------


indexing

   description: "Supply constants, character types and lexical tokens.";
   date: "$Date: 1996/07/03 23:04:58 $";
   revision: "$Revision: 1.1 $"

class S_SUPPLY

feature {ANY}

         -- constants 

   ch_letter,     -- types of characters  
   ch_apo,
   ch_digit,
   ch_underline,
   ch_space,
   ch_newline,
   ch_quote,
   ch_bracket,
   ch_other:      INTEGER is unique

   tc_ident,      -- types of lexical tokens         
   tc_number,     --  (first level)       
   tc_string,
   tc_space,
   tc_line,
   tc_symb,
   tc_comment,
   tc_eof:        INTEGER is unique

   char_type (ch: CHARACTER): INTEGER is
      do
         inspect ch
         when 'a'..'z' then
            Result := ch_letter
         when 'A'..'Z' then
            Result := ch_letter
         when '0'..'9' then
            Result := ch_digit
         when '_' then
            Result := ch_underline
         when ' ', '%T' then
            Result := ch_space
         when '%N', '%R' then
            Result := ch_newline
         when '%'', '%"' then
            Result := ch_quote
         when '(', ')', '[', ']', '{', '}' then
            Result := ch_bracket
         else
            Result := ch_other
         end
      end -- char_type 

end -- class S_SUPPLY       
