--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

   description: "Get a lexical token.";
   date: "$Date: 1996/07/03 23:06:07 $";
   revision: "$Revision: 1.1 $"

deferred class TOKEN
-- get the next input symbol       

   inherit

      S_SUPPLY

feature {ANY}

   init (i: F_INPUT) is
      do
         input_stream := i
      end

   last_token: STRING is
      do
         Result := token_string
      end -- last_token

   get_token is
      local
         token_end: BOOLEAN
      do
         from
            token_ptr := 0
            !!token_string.make (10)
         until
            token_end
         loop
            store (input_stream.last_char)
            input_stream.get_char
            token_end := input_stream.end_of_input 
            or else is_break (input_stream.last_char)
         end
      end -- get_token 

   action is
      deferred
      end

   strip_text is
      do
         token_string := token_string.substring (1, token_ptr)
      end

   last_token_type: INTEGER

feature {TOKEN}

   token_ptr:    INTEGER
   token_string: STRING
   input_stream: F_INPUT

   is_break (ch: CHARACTER): BOOLEAN is
      deferred
      end

   store (ch: CHARACTER) is
      do
         token_ptr := token_ptr + 1
         if token_ptr > token_string.count then
            token_string.append ("           ")
         end
         token_string.put (ch, token_ptr)
      end -- store     

end -- class TOKEN          
