--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

	description: "Eiffel class format skeleton";
	date: "$Date: 1996/07/03 22:57:27 $";
	revision: "$Revision: 1.1 $";
 	original_author: "$Neil Wilson $";
	modified_by: "$Valentino Kyriakides$"

deferred class EIFFEL_FORMAT

inherit
		
	FORMATTABLE_IO
		
feature -- Eiffel class output facilities
	
	
	make is
		do
		  -- nothing
		end; -- make
		
	italic_write (s: STRING) is
			-- Output 's' in italics format
		require
			s /= Void
		do
			italic_on;
			write (s);
			italic_off
		end; -- italic_write
	
	
	normal_write (s: STRING) is
			-- Output 's' without any formatting
		require
			s /= Void
		do
			normal_on;
			write (s)
			normal_off;
		end; -- normal_write
	
	bold_write (s: STRING) is
			-- Output 's' in keyword format
		require
			s /= Void
		do
			bold_on;
			write (s);
			bold_off
		end; -- bold_write
	
	bi_both_write (s: STRING) is
			-- Output 's' in keyword format
		require
			s /= Void
		do
			bold_on;
			italic_on;
			write (s);
			italic_off
			bold_off
		end; -- bi_both_write
		
	end_class is
			-- Finish formatting an eiffel class
		deferred
		end; -- end_class
				
	comment_process (s: STRING) is
			-- Post process a comment line.
		require
			s /= Void
		deferred
		end; -- comment_process
	
end -- class EIFFEL_FORMAT
