--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

   description: "Read input characters from a file.";
   date: "$Date: 1996/07/03 23:03:51 $";
   revision: "$Revision: 1.1 $";
	author: "$Author: vkyr $"

class F_INPUT

   inherit
      S_INPUT

creation
   access

feature

   access (ps: STRING) is
      do
			fname := ps
         !!f.connect_to(ps)
      end -- access    

   file_exists: BOOLEAN is
      do
         Result := f.exists(fname)
      end -- file_exists          

   open is
      do
         -- do nothing here for SmallEiffel
      end -- open      

   end_of_input : BOOLEAN is
      do
         Result := f.end_of_input and then ptr = buffer.count;
      end -- end_of_input         

   get_char is
      do
         if not end_of_input then
            if buffer = void or else ptr = buffer.count then
               f.read_line;
               buffer := f.last_string;
               buffer.extend ('%N');
               ptr := 1;
            else
               ptr := ptr + 1
            end
         end
      end -- get_char  

   last_char : CHARACTER is
      do
         Result := buffer.item (ptr)
      end -- last_char 

feature {NONE}  -- protected features   

   f:  STD_FILE_READ_WRITE
   ptr: INTEGER
   buffer: STRING
   fname: STRING
	
end -- class F_INPUT        
