--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

	description: "IO with limited formatting capability";
	date: "$Date: 1996/07/03 23:04:04 $";
	revision: "$Revision: 1.1 $";
 	original_author: "$Neil Wilson $";
	modified_by: "$Valentino Kyriakides$"

deferred class FORMATTABLE_IO


feature -- initialisation/termination
	
	start_output is
			-- Set up the formatter for outputting text on a page.
		deferred
		end; -- start_output
	
	end_output is
			-- Close down the formatter
		deferred
		end; -- end_output
	
feature -- output generators
	
	write,
	output (s: STRING) is
			-- Place 's' on the output medium in current place.
		require
			available: s /= Void
		deferred
		end; -- write, output
	
	hard_space is
			-- Place a non-breakable space on output medium.
		deferred
		end; -- hard_space
	
	space is
			-- Place a breakable space on output medium.
		deferred
		end; -- space
	
	next_line is
			-- Move to beginning of next line on output medium.
		deferred
		end; -- next_line
	
feature -- Typesetting features
	
	bold_on,
	bold_off,
	italic_on,
	italic_off,
	normal_on,
	normal_off is
			-- Typesetting facilities
		deferred
		end; -- bold_on,bold_off,italic_on,italic_off,normal_on,normal_off
	
end -- class FORMATTABLE_IO
