--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

   description: "Stream of input characters";
   date: "$Date: 1996/07/03 23:04:55 $";
   revision: "$Revision: 1.1 $"
	
   --|-------------------------------------------------------------------------
   --| S_INPUT must supply the followings functions to the scanner:     
   --|-------------------------------------------------------------------------
   --| access (name: STRING)  -- Creation procedure name is usually a filename.    
   --| file_exists: BOOLEAN   -- Check the existance of the accessed file.         
   --| open                   -- Open the file for reading.             
   --| close                  -- Close the file after processing.       
   --| end_of_input: BOOLEAN  -- this 3 functions are called from the scanner      
   --| last_char: CHARACTER   -- Get actual character.       
   --| get_char               -- Read next character.        
   --|-------------------------------------------------------------------------

deferred class S_INPUT

feature 

   access (ps: STRING) is
      deferred
      end

   file_exists: BOOLEAN is
      deferred
      end

   open is
      deferred
      end

   end_of_input : BOOLEAN is
      deferred
      end

   get_char is
      deferred
      end

   last_char : CHARACTER is
      deferred
      end

end -- class S_INPUT        
