--|----------------------------------------------------------------------------
--|      Part of the [E]iffel [s]ource [pretty] printer for SmallEiffel
--|                       
--|                    GNU GENERAL PUBLIC LICENSE
--|
--|    This program is free software; you can redistribute it and/or modify
--|    it under the terms of the GNU General Public License as published by
--|    the Free Software Foundation!
--|----------------------------------------------------------------------------

indexing

   description: "Symbol token.";
   date: "$Date: 1996/07/03 23:06:03 $";
   revision: "$Revision: 1.1 $"

class T_SYMB

   inherit

      TOKEN   
         rename
            get_token as n_token
         end
      TOKEN   
         redefine
            get_token
         select
            get_token
         end

feature

   is_break (ch: CHARACTER): BOOLEAN is
      local
         t: INTEGER
      do
         t := char_type (ch)
         Result := ( t = ch_letter  or else
         t = ch_digit   or else
         t = ch_space   or else
         t = ch_newline or else
         t = ch_bracket or else
         t = ch_quote )
      end -- is_break  

   get_token is
      do
         if char_type (input_stream.last_char) = ch_bracket then
            token_ptr := 0
            !!token_string.make (10)
            store (input_stream.last_char)
            input_stream.get_char
         else
            n_token
         end
      end -- get_token 

   action is
      do
            -- if we got "--..." then scan until end of line ..      
            -- (to handle Eiffel comment)      
         if token_string.count >= 2 and then
            token_string.substring (1, 2).is_equal ("--") then
            from
            until
               char_type (input_stream.last_char) = ch_newline 
            loop
               store (input_stream.last_char)
               input_stream.get_char
            end -- loop      
            last_token_type := tc_comment
         else
            last_token_type := tc_symb
         end
      end -- action    

end -- class T_SYMB 
