;;;-*-Mode:LISP; Package:PCL; Base:10; Syntax:Common-lisp -*-

(in-package :pcl)

;;; 1 arguments 
(defgeneric accessor-method-slot-name (m))
(defgeneric |ARRAY class predicate| (object))
(defgeneric |BIT-VECTOR class predicate| (object))
(defgeneric |BUILT-IN-CLASS class predicate| (object))
(defgeneric |CHARACTER class predicate| (object))
(defgeneric class-can-precede-list (pcl-class))
(defgeneric class-constructors (class))
(defgeneric class-default-initargs (class))
(defgeneric class-defstruct-constructor (structure-class))
(defgeneric class-defstruct-form (structure-class))
(defgeneric class-direct-default-initargs (class))
(defgeneric class-direct-slots (class))
(defgeneric class-direct-subclasses (class))
(defgeneric class-direct-superclasses (class))
(defgeneric class-eq-specializer (class))
(defgeneric class-eq-specializer-p (object))
(defgeneric class-finalized-p (class))
(defgeneric class-incompatible-superclass-list (pcl-class))
(defgeneric class-name (class))
(defgeneric class-no-of-instance-slots (std-class))
(defgeneric class-precedence-list (pcl-class))
(defgeneric class-predicate-name (class))
(defgeneric class-prototype (class))
(defgeneric class-slot-cells (class))
(defgeneric class-slots (class))
(defgeneric class-wrapper (pcl-class))
(defgeneric classp (object))
(defgeneric |COMPLEX class predicate| (object))
(defgeneric compute-class-precedence-list (root))
(defgeneric compute-default-initargs (class))
(defgeneric compute-discriminating-function (gf))
(defgeneric compute-discriminating-function-arglist-info (generic-function))
(defgeneric compute-slots (class))
(defgeneric |CONS class predicate| (object))
(defgeneric |CONSTRUCTOR class predicate| (object))
(defgeneric constructor-class (constructor))
(defgeneric constructor-code-generators (constructor))
(defgeneric constructor-code-type (constructor))
(defgeneric constructor-name (constructor))
(defgeneric constructor-supplied-initarg-names (constructor))
(defgeneric definition-source (definition-source-mixin))
(defgeneric |DEFINITION-SOURCE-MIXIN class predicate| (object))
(defgeneric |DEPENDENT-UPDATE-MIXIN class predicate| (object))
(defgeneric |DIRECT-SLOT-DEFINITION class predicate| (object))
(defgeneric |DOCUMENTATION-MIXIN class predicate| (object))
(defgeneric |EFFECTIVE-SLOT-DEFINITION class predicate| (object))
(defgeneric eql-specializer-object (eql-specializer))
(defgeneric eql-specializer-p (object))
(defgeneric exact-class-specializer-p (object))
(defgeneric finalize-inheritance (class))
(defgeneric |FLOAT class predicate| (object))
(defgeneric forward-referenced-class-p (object))
(defgeneric funcallable-standard-class-p (object))
(defgeneric function-keywords (method))
(defgeneric generic-function-lambda-list (gf))
(defgeneric generic-function-method-class (standard-generic-function))
(defgeneric generic-function-method-combination (standard-generic-function))
(defgeneric generic-function-methods (standard-generic-function))
(defgeneric generic-function-name (standard-generic-function))
(defgeneric generic-function-p (object))
(defgeneric generic-function-pretty-arglist (generic-function))
(defgeneric gf-arg-info (standard-generic-function))
(defgeneric gf-dfun-state (standard-generic-function))
(defgeneric gf-pretty-arglist (standard-generic-function))
(defgeneric gf-valid-p (standard-generic-function))
(defgeneric initialize-internal-slot-functions (slotd))
(defgeneric install-lazy-constructor-installer (constructor))
(defgeneric |INTEGER class predicate| (object))
(defgeneric |LIST class predicate| (object))
(defgeneric |LONG-METHOD-COMBINATION class predicate| (object))
(defgeneric long-method-combination-function (long-method-combination))
(defgeneric make-instances-obsolete (class))
(defgeneric |METAOBJECT class predicate| (object))
(defgeneric method-closure-generator (standard-method))
(defgeneric method-combination-documentation (standard-method-combination))
(defgeneric method-combination-options (standard-method-combination))
(defgeneric method-combination-p (object))
(defgeneric method-combination-type (standard-method-combination))
(defgeneric method-function (traced-method))
(defgeneric method-function-for-caching-p (method))
(defgeneric method-function-name (standard-method))
(defgeneric method-generic-function (traced-method))
(defgeneric method-lambda-list (m))
(defgeneric method-p (object))
(defgeneric method-pretty-arglist (method))
(defgeneric method-qualifiers (m))
(defgeneric method-specializers (m))
(defgeneric |NULL class predicate| (object))
(defgeneric |NUMBER class predicate| (object))
(defgeneric object-plist (plist-mixin))
(defgeneric |PCL-CLASS class predicate| (object))
(defgeneric |PLIST-MIXIN class predicate| (object))
(defgeneric |RATIO class predicate| (object))
(defgeneric |RATIONAL class predicate| (object))
(defgeneric raw-instance-allocator (class))
(defgeneric |SEQUENCE class predicate| (object))
(defgeneric short-combination-identity-with-one-argument (short-method-combination))
(defgeneric short-combination-operator (short-method-combination))
(defgeneric short-method-combination-p (object))
(defgeneric |SLOT-CLASS class predicate| (object))
(defgeneric |SLOT-DEFINITION class predicate| (object))
(defgeneric slot-definition-allocation (slotd))
(defgeneric slot-definition-boundp-function (effective-slot-definition))
(defgeneric slot-definition-class (slot-definition))
(defgeneric slot-definition-defstruct-accessor-symbol (structure-slot-definition))
(defgeneric slot-definition-initargs (slot-definition))
(defgeneric slot-definition-initform (slot-definition))
(defgeneric slot-definition-initfunction (slot-definition))
(defgeneric slot-definition-internal-reader-function (structure-slot-definition))
(defgeneric slot-definition-internal-writer-function (structure-slot-definition))
(defgeneric slot-definition-location (standard-effective-slot-definition))
(defgeneric slot-definition-name (slot-definition))
(defgeneric slot-definition-reader-function (effective-slot-definition))
(defgeneric slot-definition-readers (slot-definition))
(defgeneric slot-definition-type (slot-definition))
(defgeneric slot-definition-writer-function (effective-slot-definition))
(defgeneric slot-definition-writers (slot-definition))
(defgeneric |SLOT-OBJECT class predicate| (object))
(defgeneric slots-fetcher (class))
(defgeneric specializer-class (class-eq-specializer))
(defgeneric specializer-direct-generic-functions (specializer))
(defgeneric specializer-direct-methods (specializer))
(defgeneric specializer-method-table (specializer))
(defgeneric specializer-object (eql-specializer))
(defgeneric specializer-type (specializer))
(defgeneric |SPECIALIZER-WITH-OBJECT class predicate| (object))
(defgeneric specializerp (object))
(defgeneric standard-accessor-method-p (object))
(defgeneric standard-boundp-method-p (object))
(defgeneric standard-class-p (object))
(defgeneric |STANDARD-DIRECT-SLOT-DEFINITION class predicate| (object))
(defgeneric |STANDARD-EFFECTIVE-SLOT-DEFINITION class predicate| (object))
(defgeneric standard-generic-function-p (object))
(defgeneric |STANDARD-METHOD-COMBINATION class predicate| (object))
(defgeneric standard-method-p (object))
(defgeneric |STANDARD-OBJECT class predicate| (object))
(defgeneric standard-reader-method-p (object))
(defgeneric |STANDARD-SLOT-DEFINITION class predicate| (object))
(defgeneric standard-writer-method-p (object))
(defgeneric |STD-CLASS class predicate| (object))
(defgeneric |STRING class predicate| (object))
(defgeneric structure-class-p (object))
(defgeneric |STRUCTURE-DIRECT-SLOT-DEFINITION class predicate| (object))
(defgeneric |STRUCTURE-EFFECTIVE-SLOT-DEFINITION class predicate| (object))
(defgeneric |STRUCTURE-OBJECT class predicate| (object))
(defgeneric |STRUCTURE-SLOT-DEFINITION class predicate| (object))
(defgeneric |SYMBOL class predicate| (object))
(defgeneric |T class predicate| (object))
(defgeneric |TRACED-METHOD class predicate| (object))
(defgeneric update-constructors (class))
(defgeneric |VECTOR class predicate| (object))
(defgeneric wrapper-fetcher (class))
(defgeneric slot-accessor-name::|LISP FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|LISP TYPE slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL ACCESSOR-FLAGS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL ALLOCATION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL ARG-INFO slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL BOUNDP-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CAN-PRECEDE-LIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CLASS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CLASS-EQ-SPECIALIZER slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CLASS-PRECEDENCE-LIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CLOSURE-GENERATOR slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CODE-GENERATORS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL CODE-TYPE slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-ACCESSOR-SYMBOL slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-CONSTRUCTOR slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-FORM slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DFUN-STATE slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-METHODS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SLOTS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SUBCLASSES slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SUPERCLASSES slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL DOCUMENTATION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL FROM-DEFCLASS-P slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL FUNCTION-NAME slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL GENERIC-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL IDENTITY-WITH-ONE-ARGUMENT slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INCOMPATIBLE-SUPERCLASS-LIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INITARGS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INITFORM slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INITFUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INTERNAL-READER-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL INTERNAL-WRITER-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL LAMBDA-LIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL LOCATION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL METHOD slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL METHOD-CLASS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL METHOD-COMBINATION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL METHODS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL NAME slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL NO-OF-INSTANCE-SLOTS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL OBJECT slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL OPERATOR slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL OPTIONS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL PLIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL PREDICATE-NAME slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL PRETTY-ARGLIST slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL PROTOTYPE slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL READER-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL READERS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL SLOT-NAME slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL SLOTS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL SOURCE slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL SPECIALIZERS slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL SUPPLIED-INITARG-NAMES slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL VALID-P slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL WRAPPER slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL WRITER-FUNCTION slot READER| (slot-object))
(defgeneric slot-accessor-name::|PCL WRITERS slot READER| (slot-object))

;;; 2 arguments 
(defgeneric add-constructor (class constructor))
(defgeneric add-dependent (metaobject dependent))
(defgeneric add-direct-method (specializer method))
(defgeneric add-direct-subclass (class subclass))
(defgeneric add-method (generic-function method))
(defgeneric change-class (instance new-class))
(defgeneric (setf class-defstruct-constructor) (new-value structure-class))
(defgeneric (setf class-defstruct-form) (new-value structure-class))
(defgeneric (setf class-direct-slots) (new-value slot-class))
(defgeneric (setf class-incompatible-superclass-list) (new-value pcl-class))
(defgeneric (setf class-name) (new-value class))
(defgeneric (setf class-no-of-instance-slots) (new-value std-class))
(defgeneric class-slot-value (class slot-name))
(defgeneric (setf class-slots) (new-value slot-class))
(defgeneric compatible-meta-class-change-p (class proto-new-class))
(defgeneric compute-applicable-methods (generic-function arguments))
(defgeneric compute-applicable-methods-using-classes (generic-function classes))
(defgeneric compute-constructor-code (class constructor))
(defgeneric compute-effective-slot-definition (class dslotds))
(defgeneric compute-effective-slot-definition-initargs (class direct-slotds))
(defgeneric (setf constructor-code-type) (new-value constructor))
(defgeneric default-initargs (class supplied-initargs))
(defgeneric describe-object (class stream))
(defgeneric direct-slot-definition-class (class initargs))
(defgeneric effective-slot-definition-class (class initargs))
(defgeneric (setf generic-function-method-class) (new-value standard-generic-function))
(defgeneric (setf generic-function-method-combination) (new-value standard-generic-function))
(defgeneric (setf generic-function-methods) (new-value standard-generic-function))
(defgeneric (setf generic-function-name) (new-value standard-generic-function))
(defgeneric (setf gf-dfun-state) (new-value standard-generic-function))
(defgeneric (setf gf-pretty-arglist) (new-value standard-generic-function))
(defgeneric (setf gf-valid-p) (new-value standard-generic-function))
(defgeneric inform-type-system-about-class (class name))
(defgeneric legal-documentation-p (object x))
(defgeneric legal-lambda-list-p (object x))
(defgeneric legal-method-function-p (object x))
(defgeneric legal-qualifier-p (object x))
(defgeneric legal-qualifiers-p (object x))
(defgeneric legal-slot-name-p (object x))
(defgeneric legal-specializer-p (object x))
(defgeneric legal-specializers-p (object x))
(defgeneric make-boundp-method-function (class slot-name))
(defgeneric make-reader-method-function (class slot-name))
(defgeneric make-writer-method-function (class slot-name))
(defgeneric map-dependents (metaobject function))
(defgeneric maybe-update-constructors (generic-function method))
(defgeneric method-function-for-caching (method wrappers))
(defgeneric (setf method-function-name) (new-value standard-method))
(defgeneric (setf method-generic-function) (new-value traced-method))
(defgeneric (setf object-plist) (new-value plist-mixin))
(defgeneric print-object (instance stream))
(defgeneric remove-boundp-method (class generic-function))
(defgeneric remove-constructor (class constructor))
(defgeneric remove-dependent (metaobject dependent))
(defgeneric remove-direct-method (specializer method))
(defgeneric remove-direct-subclass (class subclass))
(defgeneric remove-method (generic-function method))
(defgeneric remove-reader-method (class generic-function))
(defgeneric remove-writer-method (class generic-function))
(defgeneric same-specializer-p (specl1 specl2))
(defgeneric slot-accessor-function (slotd type))
(defgeneric slot-accessor-std-p (slotd type))
(defgeneric (setf slot-definition-allocation) (new-value standard-slot-definition))
(defgeneric (setf slot-definition-boundp-function) (new-value effective-slot-definition))
(defgeneric (setf slot-definition-class) (new-value slot-definition))
(defgeneric (setf slot-definition-defstruct-accessor-symbol) (new-value structure-slot-definition))
(defgeneric (setf slot-definition-initargs) (new-value slot-definition))
(defgeneric (setf slot-definition-initform) (new-value slot-definition))
(defgeneric (setf slot-definition-initfunction) (new-value slot-definition))
(defgeneric (setf slot-definition-internal-reader-function) (new-value structure-slot-definition))
(defgeneric (setf slot-definition-internal-writer-function) (new-value structure-slot-definition))
(defgeneric (setf slot-definition-location) (location slotd))
(defgeneric (setf slot-definition-name) (new-value slot-definition))
(defgeneric (setf slot-definition-reader-function) (new-value effective-slot-definition))
(defgeneric (setf slot-definition-readers) (new-value slot-definition))
(defgeneric (setf slot-definition-type) (new-value slot-definition))
(defgeneric (setf slot-definition-writer-function) (new-value effective-slot-definition))
(defgeneric (setf slot-definition-writers) (new-value slot-definition))
(defgeneric slots-to-inspect (class object))
(defgeneric update-gf-dfun (class gf))
(defgeneric validate-superclass (class new-super))
(defgeneric slot-accessor-name::|PCL ACCESSOR-FLAGS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL ALLOCATION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL ARG-INFO slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL BOUNDP-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CAN-PRECEDE-LIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CLASS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CLASS-EQ-SPECIALIZER slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CLASS-PRECEDENCE-LIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CLOSURE-GENERATOR slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CODE-GENERATORS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL CODE-TYPE slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-ACCESSOR-SYMBOL slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-CONSTRUCTOR slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DEFSTRUCT-FORM slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DFUN-STATE slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-METHODS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SLOTS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SUBCLASSES slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DIRECT-SUPERCLASSES slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL DOCUMENTATION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL FROM-DEFCLASS-P slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL FUNCTION-NAME slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL GENERIC-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL IDENTITY-WITH-ONE-ARGUMENT slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INCOMPATIBLE-SUPERCLASS-LIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INITARGS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INITFORM slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INITFUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INTERNAL-READER-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL INTERNAL-WRITER-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL LAMBDA-LIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL LOCATION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL METHOD slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL METHOD-CLASS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL METHOD-COMBINATION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL METHODS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL NAME slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL NO-OF-INSTANCE-SLOTS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL OBJECT slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL OPERATOR slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL OPTIONS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL PLIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL PREDICATE-NAME slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL PRETTY-ARGLIST slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL PROTOTYPE slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL READER-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL READERS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL SLOT-NAME slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL SLOTS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL SOURCE slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL SPECIALIZERS slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL SUPPLIED-INITARG-NAMES slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL VALID-P slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL WRAPPER slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL WRITER-FUNCTION slot WRITER| (new-value slot-object))
(defgeneric slot-accessor-name::|PCL WRITERS slot WRITER| (new-value slot-object))

;;; 3 arguments 
(defgeneric add-boundp-method (class generic-function slot-name))
(defgeneric add-reader-method (class generic-function slot-name))
(defgeneric add-writer-method (class generic-function slot-name))
(defgeneric (setf class-slot-value) (nv class slot-name))
(defgeneric compute-effective-method (generic-function combin applicable-methods))
(defgeneric find-method-combination (generic-function type options))
(defgeneric (setf slot-accessor-function) (function slotd type))
(defgeneric (setf slot-accessor-std-p) (value slotd type))
(defgeneric slot-boundp-using-class (class object slotd))
(defgeneric slot-exists-p-using-class (class object slotd))
(defgeneric slot-makunbound-using-class (class object slotd))
(defgeneric slot-unbound (class instance slot-name))
(defgeneric slot-value-using-class (class object slotd))

;;; 4 arguments 
(defgeneric load-constructor-internal (class name initargs generators))
(defgeneric (setf slot-value-using-class) (new-value class object slotd))

;;; 5 arguments 
(defgeneric make-constructor-code-generators (class name lambda-list supplied-initarg-names supplied-initargs))

;;; optional arguments  
(defgeneric documentation (object &optional doc-type))
(defgeneric (setf documentation) (new-value object &optional doc-type))
(defgeneric get-constructor (class name &optional (error-p t)))
(defgeneric get-method (generic-function qualifiers specializers &optional (errorp t)))
(defgeneric remove-named-method (generic-function-name argument-specifiers &optional extra))
(defgeneric slot-missing (class instance slot-name operation &optional new-value))

;;; keyword arguments  
(defgeneric allocate-instance (class &rest initargs))
(defgeneric ensure-class-using-class (name class &rest args &key &allow-other-keys))
(defgeneric ensure-generic-function-using-class (generic-function function-specifier &key &allow-other-keys))
(defgeneric initialize-instance (item &key))
(defgeneric make-instance (class &rest initargs))
(defgeneric no-applicable-method (generic-function &rest args))
(defgeneric reinitialize-instance (instance &rest initargs))
(defgeneric shared-initialize (instance slot-names &key))
(defgeneric update-instance-for-different-class (previous current &rest initargs))
(defgeneric update-instance-for-redefined-class (instance added-slots discarded-slots property-list &rest initargs))

