; Copyright (c) 1993, 1994 Richard Kelsey and Jonathan Rees.  See file COPYING.


; Link scripts.

(define (link-initial-system)
  (let ((structures-to-open		;Structures to open for the initial
	 (struct-list scheme		;system's read-eval-print loop.
		      environments
		      module-system
		      ensures-loaded
		      packages
		      packages-internal)))  ; package-for-syntax
    (link-reified-system (append (desirable-structures)
				 structures-to-open)
			 'initial
			 ;; The expression that evaluates to the
			 ;; procedure that maps the reified-structure alist
			 ;; to the startup procedure:
			 `(start ',(map car structures-to-open))
			 ;; Structures to open for evaluating that
			 ;; expression and the expression that
			 ;; evaluates to the reified-structure alist:
			 initial-system
			 for-reification
			 ;; scheme-level-1
			 )))


(define (desirable-structures)
  (let ((env (interaction-environment))
	(l '()))
    (for-each (lambda (sig)
		(for-each-declaration
		     (lambda (name type)
		       (set! l
			     (cons (cons name
					 (eval name env))
				   l)))
		     sig))
	      (list run-time-structures-interface
		    features-structures-interface
		    run-time-internals-interface
		    compiler-structures-interface
		    initial-structures-interface))
    (reverse l)))
