"======================================================================
|
|   Maps a stream of lines into a stream of whitespace collapsed tokens
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     25 Aug 94	  Prepared for release.
|
"


FileStream fileIn: 'PushBackStream.st' ifMissing: #PushBackStream !

PushBackStream subclass: #LineToTokenStream
       instanceVariableNames: 'lineStream'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!LineToTokenStream class methodsFor: 'instance creation'!

"inherit PushBackStream>>on: "
!


!LineToTokenStream methodsFor: 'accessing'!

next
    | token | 
    queue size > 0
        ifTrue: [ ^queue removeFirst ].
    
    self atEnd
	ifTrue: [ '&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& reached end' printNl. ^nil ].

    token _ self nextToken.
    (token isMemberOf: WhitespaceTok) 
	ifTrue: 
	    [ "collapse blank lines and adjacent whitespace into a single
	       whitespace"
	     [ lineStream atEnd not
		   and: [ token _ self nextToken.
			  token isMemberOf: WhitespaceTok ] ] whileTrue.
	     self putBack: token.
	     ^WhitespaceTok new.
	     ].
    ^token
!

nextBypass
    | token | 
    queue size > 0
        ifTrue: [ ^queue removeFirst ].
    
    token _ self nextToken.
    (token isMemberOf: WhitespaceTok) 
	ifTrue: 
	    [ "collapse blank lines and adjacent whitespace into a single
	       whitespace"
	     [ token _ self nextToken.
	       token isMemberOf: WhitespaceTok ] whileTrue.
	     self putBack: token.
	     ^WhitespaceTok new.
	     ].
    ^token
!

peek
    queue size == 0
	ifTrue: [ self putBack: self next ].

    ^queue at: 1
!

atEnd
    (queue size > 0) 
	ifTrue: [ ^false ].

    lineStream isNil
	ifTrue: [ stream atEnd
		      ifTrue: [ ^true ].
		  lineStream _ ReadStream on: stream next ].
    ^lineStream atEnd 
! 

atRealEnd
    (queue size > 0)
	ifTrue: [ ^false ].
    
    (lineStream isNil or: [ lineStream atEnd ])
	ifTrue: [ stream atEnd
		      ifTrue: [ ^true ]. ].
    ^false
!

close
    "do nothing"
    ^self
! !


!LineToTokenStream methodsFor: 'private'!

		 
nextToken
    | line wasAtEnd|
    (lineStream isNil or: [ lineStream atEnd ])
	  ifTrue: [ wasAtEnd _ lineStream notNil.
		    line _ stream next.
		    lineStream _ ReadStream on: line.
		    wasAtEnd ifTrue: [ "Synthesize a white token" 
				       ^WhitespaceTok new ].
		    ].
    
    ^lineStream next
! !
