"======================================================================
|
|   Smalltalk GUI toolkit independent GUI building blocks.
|
|   $Revision: 1.4 $
|   $Date: 1995/09/12 04:35:21 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      1 May 95	  Switched to using the new C type models.
|
| sbb	     12 Jul 94	  Added insert at end.
|
"

"to do
make menu items more colleciton like -- define a default target for events,
 add the label, message pairs

make color, position, perhaps other global things work properly with menus.

fix lists to put the vertical list optionally there, and deal with the 
resulting issues.
"

Object subclass: #Blox
       instanceVariableNames: 'guiObject cdata'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'bloxInit'
	 withSelectorArgs: 'bloxInit'
	 forClass: Blox class
	 returning: #void
	 args: #()
!

Behavior defineCFunc: 'beginDispatchingEvents'
	 withSelectorArgs: 'dispatchEvents'
	 forClass: Blox class
	 returning: #void
	 args: #()
!

Behavior defineCFunc: 'terminateMainLoop'
	 withSelectorArgs: 'terminateMainLoop'
	 forClass: Blox class
	 returning: #void
	 args: #()
!

Behavior defineCFunc: 'createColor'
	 withSelectorArgs: 'createColor: red green: green blue: blue'
	 forClass: Blox class
	 returning: #cObject
	 args: #(int int int)
! 

Smalltalk at: #KeepBrowserRunning put: true!

!Blox class methodsFor: 'private utility'!

defineCommonProtocol: typeName for: class
    self defineColorProtocol: typeName for: class.
    self defineSizeProtocol: typeName for: class.
    self defineMiscProtocol: typeName for: class.
!

defineColorProtocol: typeName for: class
    "Accessors"
    Behavior defineCFunc: 'get', typeName, 'ForegroundColor'
	     withSelectorArgs: 'getForeground: guiObject'
	     forClass: class
	     returning: #cObject
	     args: #(cObject).

    Behavior defineCFunc: 'get', typeName, 'BackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: class
	     returning: #cObject
	     args: #(cObject).

    "Mutators"
    Behavior defineCFunc: 'set', typeName, 'ForegroundColor'
	     withSelectorArgs: 'setForeground: guiObject color: aColor'
	     forClass: class
	     returning: #void
	     args: #(cObject cObject).

    Behavior defineCFunc: 'set', typeName, 'BackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: class
	     returning: #void
	     args: #(cObject cObject).
!

defineSizeProtocol: typeName for: class
    "Accessors"

    Behavior defineCFunc: 'get', typeName, 'Height'
	     withSelectorArgs: 'getHeight: guiObject'
	     forClass: class
	     returning: #long
	     args: #(cObject).

    Behavior defineCFunc: 'get', typeName, 'Width'
	     withSelectorArgs: 'getWidth: guiObject'
	     forClass: class
	     returning: #long
	     args: #(cObject).

    Behavior defineCFunc: 'get', typeName, 'X'
	     withSelectorArgs: 'getX: guiObject'
	     forClass: class
	     returning: #long
	     args: #(cObject).

    Behavior defineCFunc: 'get', typeName, 'Y'
	     withSelectorArgs: 'getY: guiObject'
	     forClass: class
	     returning: #long
	     args: #(cObject).
    
    "Mutators"
    Behavior defineCFunc: 'set', typeName, 'Height'
	     withSelectorArgs: 'set: guiObject height: height'
	     forClass: class
	     returning: #void
	     args: #(cObject long).

    Behavior defineCFunc: 'set', typeName, 'Width'
	     withSelectorArgs: 'set: guiObject width: width'
	     forClass: class
	     returning: #void
	     args: #(cObject long).

    Behavior defineCFunc: 'set',typeName, 'X'
	     withSelectorArgs: 'set: guiObject x: x'
	     forClass: class
	     returning: #void
	     args: #(cObject long).

    Behavior defineCFunc: 'set', typeName, 'Y'
	     withSelectorArgs: 'set: guiObject y: y'
	     forClass: class
	     returning: #void
	     args: #(cObject long).
!

defineMiscProtocol: typeName for: class
    Behavior defineCFunc: 'set', typeName, 'Enabled'
	     withSelectorArgs: 'set: guiObject enabled: enabledBool'
	     forClass: class
	     returning: #void
	     args: #(cObject int).

    Behavior defineCFunc: 'get', typeName, 'Enabled'
	     withSelectorArgs: 'getEnabled: guiObject'
	     forClass: class
	     returning: #int
	     args: #(cObject).

    Behavior defineCFunc: 'destroy', typeName, 'Widget'
	 withSelectorArgs: 'destroy: guiObject'
	 forClass: class
	 returning: #void
	 args: #(cObject).

    Behavior defineCFunc: 'getContainer', typeName, 'Object'
	 withSelectorArgs: 'getContainerObject: guiObject'
	 forClass: class
	 returning: #cObject
	 args: #(cObject).

    Behavior defineCFunc: 'getConnected', typeName, 'Object'
	 withSelectorArgs: 'getConnectedObject: guiObject'
	 forClass: class
	 returning: #cObject
	 args: #(cObject).
! !


! Blox methodsFor: 'private' !

alloc: size
"Dynamically allocate memory within Smalltalk. Create an instance of
ByteArray of size and add to set, cdata. When (self) is garbage
collected, data allocated and stored in self's private memory is also
garbage collected.  The central advantage of this method is that the
memory allocated for callbacks does not need to be explicitly managed
within C.  When the widget tied to self is destroyed, the memory
allocated for each Widget callback will be transparently released when
self is subsequently garbage collected"
| s |
    cdata isNil ifTrue: [ cdata := OrderedCollection new ].
    s := ByteArray new: size.
    cdata add: s.
    ^s
!!

!Blox methodsFor: 'accessing'!

guiObject
    ^guiObject
!

release
    self destroy: guiObject.
    guiObject _ nil.
!

getContainerObject
    ^self getContainerObject: guiObject
!

getConnectedObject
    "A connected object is one that has useful state defined.  For example,
     a Xt simple menu does not have a valid color map associated with it when 
     it is not displayed, but it's containing MenuButton does, so that's what
     this function is supposed to return.  Normally, it's the same as 
     the getContainerObject."
    ^self getConnectedObject: guiObject
! ! 


!Blox methodsFor: 'common protocol'!

"NOTE: some of these may not be suitable for all Blox subclasses."

height
    ^self getHeight: guiObject
!

height: height
    self set: guiObject height: height
!

width
    ^self getWidth: guiObject
!

width: width
    self set: guiObject width: width
!

pos
    ^(self x) @ (self y)
!

pos: position			"a point"
    self x: position x;
	y: position y
!

x
    ^self getX: guiObject
!

x: x
    self set: guiObject x: x
!

y
    ^self getY: guiObject
!

y: y
    self set: guiObject y: y
!

enabled
    ^self getEnabled: guiObject.
!

enabled: enabledBool
    self set: guiObject enabled: enabledBool
!

foregroundColor
    ^self getForeground: guiObject
!

foregroundColor: aColor
    self setForeground: guiObject color: aColor
!

backgroundColor
    ^self getBackground: guiObject
!

backgroundColor: aColor
    self setBackground: guiObject color: aColor
! !


Blox subclass: #BloxCollection
       instanceVariableNames: 'collection'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

BloxCollection comment:
'I am the abstract base class for the Blox objects which represent collections
of things: lists, menus, menu bars, and radio groups.  I provide the standard
protocol, and the representation (Smalltalk) for the collection'!

!BloxCollection class methodsFor: 'instance creation'!

new
    ^super new init
! !


!BloxCollection methodsFor: 'accessing'!

add: anElement
    ^self addLast: anElement
!

remove: anElement
    collection remove: anElement.
    "notify the unerlying gui object"
    self remove: guiObject element: anElement guiObject.
!

replaceAll: aCollection
    | type array i |
    collection _ OrderedCollection new.
    collection addAll: aCollection.
    "notify the underlying GUI object"

    type _ CArrayCType elementType: CStringType
		 numberOfElements: collection size.
    array _ type new.
    i _ 0.
    collection do: [ :element | array at: i put: element guiObject.
				i _ i + 1 ].

    self set: guiObject contents: array size: array size.
! !




!BloxCollection methodsFor: 'private'!

init
    collection _ OrderedCollection new.
! !




Blox subclass: #BLabel
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createLabel'
	 withSelectorArgs: 'createLabel: parent label: label'
	 forClass: BLabel
	 returning: #cObject	"could be more specific"
	 args: #(cObject string)
!


Blox defineCommonProtocol: 'Label' for: BLabel!

!BLabel class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label
! !


!BLabel methodsFor: 'private'!

init: parent label: label
    guiObject _ self createLabel: parent getContainerObject label: label.
! !





Blox subclass: #BButton
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createButton'
	 withSelectorArgs: 'createButton: parent label: label'
	 forClass: BButton class
	 returning: #cObject	"could be more specific"
	 args: #(cObject string)
!

Blox defineCommonProtocol: 'Button' for: BButton!


Behavior defineCFunc: 'setButtonCallback'
	 withSelectorArgs: 'setCallback: button receiver: receiver message: message'
	 forClass: BButton
	 returning: #void
	 args: #(cObject smalltalk string)
!

!BButton class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label
! !


!BButton methodsFor: 'testing'!

buttonPressed
    'button pressed!' printNl
!

quitPressed
    'quit button pressed!' printNl.
    KeepBrowserRunning _ false.
    Blox terminateMainLoop.
!

restartPressed
    'restart button pressed!' printNl.
    Blox terminateMainLoop.
!

testError
    'testing error!' printNl.
    self error: 'error test'
!

helpPressed
    'help button pressed!' printNl
! !


!BButton methodsFor: 'accessing'!

callback: aReceiver message: aString
    self setCallback: guiObject receiver: aReceiver message: aString
! !


!BButton methodsFor: 'private'!

init: parent label: label
    guiObject _ BButton createButton: parent getContainerObject label: label.
! !



Blox subclass: #BContainer
       instanceVariableNames: 'children'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createContainer'
	 withSelectorArgs: 'createContainer: parent'
	 forClass: BContainer class
	 returning: #cObject
	 args: #(cObject)
!

" !!! NOT YET IMPLEMENTED!
Behavior defineCFunc: 'getContainerLayout'
	 withSelectorArgs: 'getLayout: container'
	 forClass: BContainer
	 returning: #int
	 args: #(cObject)
!
"

Behavior defineCFunc: 'setContainerLayout'
	 withSelectorArgs: 'set: container layout: isVertical'
	 forClass: BContainer
	 returning: #void
	 args: #(cObject int)
!

Behavior defineCFunc: 'getContainerBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BContainer
	     returning: #cObject
	     args: #(cObject)
!


Behavior defineCFunc: 'setContainerBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BContainer
	     returning: #void
	     args: #(cObject cObject)
!

Blox defineSizeProtocol: 'Container' for: BContainer!
Blox defineMiscProtocol: 'Container' for: BContainer!


!BContainer class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent
! !

!BContainer methodsFor: 'accessing'!

foregroundColor
    ^self shouldNotImplement
!

foregroundColor: color
    ^self shouldNotImplement
!

getVerticalLayout
    ^self getLayout: guiObject
!

setVerticalLayout: isVertical
    self set: guiObject layout: isVertical
! !

!BContainer methodsFor: 'private'!

init: parent
    guiObject _ BContainer createContainer: parent getContainerObject.
    children _ OrderedCollection new.
! !


Blox subclass: #BList
       instanceVariableNames: 'labels items callbackReceiver callbackSelector'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createList'
	 withSelectorArgs: 'createList: parent'
	 forClass: BList class
	 returning: #cObject
	 args: #(cObject)
!


Blox defineCommonProtocol: 'List' for: BList!

Behavior defineCFunc: 'setListCallback'
	 withSelectorArgs: 'setCallback: list receiver: receiver message: message'
	 forClass: BList
	 returning: #void
	 args: #(cObject smalltalk string)
!

Behavior defineCFunc: 'setListContents'
	 withSelectorArgs: 'set: guiObject contents: cStringArray'
	 forClass: BList 
	 returning: #void
	 args: #(cObject cObject)
!


" !!! NOT YET IMPLEMENTED
Behavior defineCFunc: 'getVerticalLayout'
	 withSelectorArgs: 'getLayout: guiObject'
	 forClass: BList 
	 returning: #int
	 args: #(cObject)
!
"

Behavior defineCFunc: 'setVerticalLayout'
	 withSelectorArgs: 'set: guiObject verticalLayout: aBoolean'
	 forClass: BList 
	 returning: #void
	 args: #(cObject int)
!

Behavior defineCFunc: 'setNumberOfColumns'
	 withSelectorArgs: 'set: guiObject numberOfColumns: numCols'
	 forClass: BList 
	 returning: #void
	 args: #(cObject long)
!

Behavior defineCFunc: 'numberOfStrings'
	 withSelectorArgs: 'numberOfStrings: guiObject'
	 forClass: BList 
	 returning: #long
	 args: #(cObject)
!

Behavior defineCFunc: 'listHighlight'
	 withSelectorArgs: 'listHighlight: guiObject item: itemNumber'
	 forClass: BList 
	 returning: #void
	 args: #(cObject int)
!

Behavior defineCFunc: 'listUnhighlight'
	 withSelectorArgs: 'listUnhighlight: guiObject'
	 forClass: BList 
	 returning: #void
	 args: #(cObject)
!

!BList class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent
! !

!BList methodsFor: 'callbacks'!

itemSelected: receiver at: index 
    stdout nextPutAll: 'List item '; print: index;
	nextPutAll: ' selected!'; nl.
    stdout nextPutAll: 'Contents: '; nextPutAll: (items at: index + 1); nl.
! !


!BList methodsFor: 'Accessing'!

at: anIndex
    items isNil
	ifTrue: [ ^labels at: anIndex + 1 ]
	ifFalse: [ ^items at: anIndex + 1 ]
!

labelAt: anIndex
    ^labels at: anIndex + 1

! !

!BList methodsFor: 'modification'!

contents: stringCollection
    ^self contents: stringCollection elements: nil
!

contents: stringCollection elements: elementList
    | array type size i name | 
    size _ stringCollection size.

    (elementList notNil
	 and: [ elementList size ~= size ])
	ifTrue: [ ^self error: 'label collection must have the same size as element collection' ].

    "Not the right code -- types should have a 'new' type operation
     on them"
    type _ CArrayCType elementType: CStringType numberOfElements: size + 1.
    array _ type new.
    i _ 0.
    labels _ OrderedCollection new: size.
    "with this implementation, allocating size+1 is overkill "
    stringCollection do: 
	[ :element | array at: i put: element.
		     labels addLast: element.
		     i _ i + 1 ].
    array at: i put: nil.

    elementList notNil
	ifTrue: [ items _ elementList asOrderedCollection ]
	ifFalse: [ items _ nil ].

    self set: guiObject contents: array.
!

rowSpacing: spacing
    self set: guiObject rowSpacing: spacing
!

columnSpacing: spacing
    self set: guiObject columnSpacing: spacing
!

numberOfColumns: numCols
    self set: guiObject numberOfColumns: numCols
!

usingVerticalLayout
    ^self getLayout: guiObject
!

useVerticalLayout: verticalBool
    self set: guiObject verticalLayout: verticalBool
!

numberOfStrings
    ^self numberOfStrings: guiObject
!

highlight: number
	 self listHighlight: guiObject item: (number - 1)
!

unhighlight
	 self listUnhighlight: guiObject.
!

callback: aReceiver message: aString
    callbackReceiver _ aReceiver.
    callbackSelector _ aString asSymbol.
    self setCallback: guiObject receiver: self message: 'calledBackFor:'.
!

x: xPos y: yPos
    self x: xPos; y: yPos
! !


!BList methodsFor: 'private'!

init: parent
    labels _ OrderedCollection new.
    guiObject _ BList createList: parent getContainerObject.
!

calledBackFor: anIndex
    callbackReceiver perform: callbackSelector with: self with: anIndex
! !


"------------------------------ Menu Bar ------------------------------"

BloxCollection subclass: #BMenuBar
     instanceVariableNames: ''
     classVariableNames: ''
     poolDictionaries: ''
     category: nil
! 


Behavior defineCFunc: 'createMenuBar'
	 withSelectorArgs: 'createMenuBar: parent'
	 forClass: BMenuBar class
	 returning: #cObject
	 args: #(cObject)
!


Behavior defineCFunc: 'addMenu'
	 withSelectorArgs: 'add: guiObject element: anElement'
	 forClass: BMenuBar
	 returning: #void
	 args: #(cObject cObject)
!


Behavior defineCFunc: 'removeMenu'
	 withSelectorArgs: 'remove: guiObject element: anElement'
	 forClass: BMenuBar
	 returning: #void
	 args: #(cObject cObject)
!

Behavior defineCFunc: 'getMenuBarBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BMenuBar
	     returning: #cObject
	     args: #(cObject)
!


Behavior defineCFunc: 'setMenuBarBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BMenuBar
	     returning: #void
	     args: #(cObject cObject)
!

Blox defineSizeProtocol: 'MenuBar' for: BMenuBar!
Blox defineMiscProtocol: 'MenuBar' for: BMenuBar!


!BMenuBar class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent
! !


!BMenuBar methodsFor: 'accessing'!

add: aMenu
    self add: guiObject element: aMenu guiObject
!

remove: aMenu
    self remove: guiObject element: aMenu guiObject
!

foregroundColor
    ^self shouldNotImplement
!

foregroundColor: color
    ^self shouldNotImplement
! !


!BMenuBar methodsFor: 'private'!

init: parent
    guiObject _ BMenuBar createMenuBar: parent getContainerObject
! !


"------------------------------ Menu ------------------------------"

"Forward declarations"

Smalltalk at: #BMenuItem
	   ifAbsent: [ Smalltalk at: #BMenuItem put: nil ]!

Smalltalk at: #BPopupMenu
	   ifAbsent: [ Smalltalk at: #BPopupMenu put: nil ]!


BloxCollection subclass: #BMenu
     instanceVariableNames: ''
     classVariableNames: ''
     poolDictionaries: ''
     category: nil
! 

Behavior defineCFunc: 'createMenu'
	 withSelectorArgs: 'createMenu: parent label: label'
	 forClass: BMenu 
	 returning: #cObject
	 args: #(cObject string)
!

Behavior defineCFunc: 'addMenuItem'
	 withSelectorArgs: 'add: guiObject element: anElement'
	 forClass: BMenu
	 returning: #void
	 args: #(cObject cObject)
!

Behavior defineCFunc: 'removeMenuItem'
	 withSelectorArgs: 'remove: guiObject element: anElement'
	 forClass: BMenu
	 returning: #void
	 args: #(cObject cObject)
!

Blox defineCommonProtocol: 'Menu' for: BMenu!


!BMenu class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label
! !


!BMenu methodsFor: 'callback registration'!

callback: receiver using: selectorPairs
    "Receiver will be sent the callback messages.  Selector pairs
     is a collection of OrderedCollections (something that responds to at:
     and size).  Possible types are:
     ()             insert a seperator line
     (name)         create a menu item with name, but no callback
     (name symbol)  create a menu item with the given callback."

    selectorPairs do:
	[ :pair | self addMenuItemFor: pair notifying: receiver ].
! !

!BMenu methodsFor: 'private'!

init: parent label: label
    guiObject _ self createMenu: parent getContainerObject label: label.
!

addMenuItemFor: pair notifying: receiver
    pair size = 0
	ifTrue: [ ^BMenuItem new: self ].
    pair size = 1
	ifTrue: [ ^BMenuItem new: self label: (pair at: 1) ].
	  pair size = 2
	ifTrue: [^(BMenuItem new: self label: (pair at: 1))
	callback: receiver message: (pair at: 2) ].
	(BMenuItem new: self label: (pair at: 1))
	callback: receiver message: (pair at: 2) argument: (pair at: 3).
! !

"------------------------------ Popup Menu ------------------------------"

BMenu subclass: #BPopupMenu
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createPopupMenu'
	 withSelectorArgs: 'createMenu: parent label: label'
	 forClass: BPopupMenu
	 returning: #cObject
	 args: #(cObject string)
!


"------------------------------ Menu Item ------------------------------"


Blox subclass: #BMenuItem
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


Behavior defineCFunc: 'createMenuItem'
	 withSelectorArgs: 'createMenuItem: parent label: label'
	 forClass: BMenuItem
	 returning: #cObject
	 args: #(cObject string)
!

Behavior defineCFunc: 'createMenuItemLine'
	 withSelectorArgs: 'createMenuItemLine: parent'
	 forClass: BMenuItem
	 returning: #cObject
	 args: #(cObject)
!

Behavior defineCFunc: 'setMenuItemCallback'
	 withSelectorArgs: 'setCallback: button receiver: receiver message: message'
	 forClass: BMenuItem
	 returning: #void
	 args: #(cObject smalltalk string)
!

Behavior defineCFunc: 'setMenuItemKeywordCallback'
	 withSelectorArgs: 'setCallback: button receiver: receiver message: message argument: anObject'
	 forClass: BMenuItem
	 returning: #void
	 args: #(cObject smalltalk string smalltalk)
!


Behavior defineCFunc: 'getMenuItemForegroundColor'
	 withSelectorArgs: 'getForeground: guiObject'
	 forClass: BMenuItem
	 returning: #cObject
	 args: #(cObject)
!


Behavior defineCFunc: 'setMenuItemForegroundColor'
	 withSelectorArgs: 'setForeground: guiObject color: aColor'
	 forClass: BMenuItem
	 returning: #void
	 args: #(cObject cObject)
!

Blox defineSizeProtocol: 'MenuItem' for: BMenuItem!
Blox defineMiscProtocol: 'MenuItem' for: BMenuItem!


!BMenuItem class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label
!

new: parent
    ^super new init: parent
! !


!BMenuItem methodsFor: 'accessing'!

callback: aReceiver message: anObject
    self setCallback: guiObject receiver: aReceiver message: anObject.
!

callback: aReceiver message: aSymbol argument: anObject
    self setCallback: guiObject receiver: aReceiver message: aSymbol argument: anObject.
!

itemChosen
    'Picked me!!!' printNl.
!

pickMeHarder
    'Pick me harder' printNl.
! !


!BMenuItem methodsFor: 'disallowed operations'!

getBackground
    ^self shouldNotImplement
!

setBackground: guiObject color: aColor
    ^self shouldNotImplement
! !


!BMenuItem methodsFor: 'private'!

init: parent label: label
    "Special case here since the parent is more constrained"
    guiObject _ self createMenuItem: parent guiObject label: label.
!

init: parent
    "Special case here since the parent is more constrained"
    guiObject _ self createMenuItemLine: parent guiObject.
! !


"------------------------------ Radio Group ------------------------------"

Blox subclass: #BRadioGroup
     instanceVariableNames: ''
     classVariableNames: ''
     poolDictionaries: ''
     category: nil
! 


Behavior defineCFunc: 'createRadioGroup'
	 withSelectorArgs: 'createRadioGroup: parent '
	 forClass: BRadioGroup class
	 returning: #cObject
	 args: #(cObject)
!


Behavior defineCFunc: 'getRadioGroupBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BRadioGroup
	     returning: #cObject
	     args: #(cObject)
!

Behavior defineCFunc: 'setRadioGroupBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BRadioGroup
	     returning: #void
	     args: #(cObject cObject)
!

Blox defineSizeProtocol: 'RadioGroup' for: BRadioGroup!
Blox defineMiscProtocol: 'RadioGroup' for: BRadioGroup!


!BRadioGroup class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent
! !


!BRadioGroup methodsFor: 'accessing'!

getForeground: guiObject
    ^self shouldNotImplement
!

setForeground: guiObject color: aColor
    ^self shouldNotImplement
! !


!BRadioGroup methodsFor: 'private'!

init: parent 
    guiObject _ BRadioGroup createRadioGroup: parent getContainerObject.
! !


"------------------------------ Radio buttons ------------------------------"

Blox subclass: #BRadioButton
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


Behavior defineCFunc: 'createRadioButton'
	 withSelectorArgs: 'createRadioButton: parent label: label'
	 forClass: BRadioButton
	 returning: #cObject
	 args: #(cObject string)
!


Behavior defineCFunc: 'setRadioButtonCallback'
	 withSelectorArgs: 'setCallback: button receiver: receiver message: message'
	 forClass: BRadioButton
	 returning: #void
	 args: #(cObject smalltalk string)
!


Blox defineCommonProtocol: 'RadioButton' for: BRadioButton!


!BRadioButton class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label

! !

!BRadioButton methodsFor: 'accessing'!

callback: aReceiver message: aString
    self setCallback: guiObject receiver: aReceiver message: aString
! !


!BRadioButton methodsFor: 'private'!

init: parent label: label
    guiObject _ self createRadioButton: parent guiObject label: label
! !




"------------------------------ Text ------------------------------"

Blox subclass: #BText
     instanceVariableNames: ''
     classVariableNames: ''
     poolDictionaries: ''
     category: nil
! 

Behavior defineCFunc: 'createText'
	 withSelectorArgs: 'createText: parent editable: aBoolean'
	 forClass: BText
	 returning: #cObject
	 args: #(cObject int)
! 

Behavior defineCFunc: 'getContents'
	 withSelectorArgs: 'getContents: guiObject'
	 forClass: BText
	 returning: #string
	 args: #(cObject)
!

Behavior defineCFunc: 'setContents'
	 withSelectorArgs: 'set: guiObject contents: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!

Behavior defineCFunc: 'getSelection'
	 withSelectorArgs: 'getSelection: guiObject'
	 forClass: BText
	 returning: #string
	 args: #(cObject)
!

Behavior defineCFunc: 'insertAfterSelection'
	 withSelectorArgs: 'insert: guiObject text: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!

Behavior defineCFunc: 'insertSelectionAfterSelection'
	 withSelectorArgs: 'insert: guiObject selection: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!

Behavior defineCFunc: 'insertSelectionAfterCursor'
	 withSelectorArgs: 'insert: guiObject selectedText: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!


Behavior defineCFunc: 'replaceSelection'
	 withSelectorArgs: 'replace: guiObject selection: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!

Behavior defineCFunc: 'insertAtEnd'
	 withSelectorArgs: 'insert: guiObject atEnd: aString'
	 forClass: BText
	 returning: #void
	 args: #(cObject string)
!

Behavior defineCFunc: 'setTextCallback'
         withSelectorArgs: 'setCallback: text receiver: receiver message: message'
         forClass: BText
         returning: #void
         args: #(cObject smalltalk string)
!

Behavior defineCFunc: 'searchString'
	 withSelectorArgs: 'searchString: guiObject string: aString'
	 forClass: BText
	 returning: #int
	 args: #(cObject string)
!

Behavior defineCFunc: 'gotoLine'
         withSelectorArgs: 'gotoLine: aCObject line: anInt end: aBoolean'
	 forClass: BText
	 returning: #int
	 args: #(cObject int int)
!

Blox defineCommonProtocol: 'Text' for: BText!


!BText class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent
!

newReadOnly: parent
    ^super new initReadOnly: parent
! !

!BText methodsFor: 'accessing'!

contents
    ^self getContents: guiObject
!

contents: aString
    self set: guiObject contents: aString
!

getSelection
    ^self getSelection: guiObject
!

replaceSelection: aString
    ^self replace: guiObject selection: aString.
!

insertText: aString
    ^self insert: guiObject text: aString
!

insertSelectedText: aString
    ^self insert: guiObject selectedText: aString
!

insertTextSelection: aString
    ^self insert: guiObject selection: aString
!

insertAtEnd: aString
    ^self insert: guiObject atEnd: aString
! !


!BText methodsFor: 'private'!

init: parent
    guiObject _ self createText: parent getContainerObject editable: true.
!

initReadOnly: parent
    guiObject _ self createText: parent getContainerObject editable: false.
! !
    


"------------------------------ Toggle ------------------------------"

Blox subclass: #BToggle
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createToggle'
	 withSelectorArgs: 'createToggle: parent label: label'
	 forClass: BToggle
	 returning: #cObject
	 args: #(cObject string)
!

Behavior defineCFunc: 'setToggleCallback'
	 withSelectorArgs: 'setCallback: button receiver: receiver message: message'
	 forClass: BToggle
	 returning: #void
	 args: #(cObject smalltalk string)
!

Behavior defineCFunc: 'getToggleValue'
	 withSelectorArgs: 'value: guiObject'
	 forClass: BToggle
	 returning: #int
	 args: #(cObject)
!

Behavior defineCFunc: 'setToggleValue'
	 withSelectorArgs: 'set: guiObject value: aBoolean'
	 forClass: BToggle
	 returning: #void
	 args: #(cObject int)
!

Blox defineCommonProtocol: 'Toggle' for: BToggle!

!BToggle class methodsFor: 'instance creation'!

new: parent label: label
    ^super new init: parent label: label

! !

!BToggle methodsFor: 'accessing'!

callback: aReceiver message: aString
    self setCallback: guiObject receiver: aReceiver message: aString
!

value
    ^(self value: guiObject) ~= 0
!

value: aBoolean
    self set: guiObject value: aBoolean
! !


!BToggle methodsFor: 'private'!

init: parent label: label
    guiObject _ self createToggle: parent getContainerObject label: label
! !

"------------------------------ Window ------------------------------"



Blox subclass: #BWindow		"Top level container"
       instanceVariableNames: 'children'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

Behavior defineCFunc: 'createToplevelWindow'
	 withSelectorArgs: 'createToplevelWindow: label'
	 forClass: BWindow
	 returning: #cObject	"could be more specific"
	 args: #(string)
!

Behavior defineCFunc: 'mapWindow'
	 withSelectorArgs: 'mapWindow: aWindow'
	 forClass: BWindow
	 returning: #void
	 args: #(cObject)
!
    
Behavior defineCFunc: 'getWindowBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BWindow
	     returning: #cObject
	     args: #(cObject)
!

Behavior defineCFunc: 'setWindowBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BWindow
	     returning: #void
	     args: #(cObject cObject)
!

Behavior defineCFunc: 'setDestroyWindowCallback'
	 withSelectorArgs: 'setCallback: window receiver: receiver message: message window: guiObject'
	 forClass: BWindow
	 returning: #void
	 args: #(cObject smalltalk string cObject)
!

Blox defineSizeProtocol: 'Window' for: BWindow!
Blox defineMiscProtocol: 'Window' for: BWindow!

!BWindow class methodsFor: 'instance creation'!

new: label
    ^super new init: label
! !

!BWindow methodsFor: 'operations'!

map
    ^self mapWindow: guiObject
! !


!BWindow methodsFor: 'accessing'!

getForeground: guiObject
    ^self shouldNotImplement
!

setForeground: guiObject color: aColor
    ^self shouldNotImplement
! !

!BWindow methodsFor: 'private'!

init: label
    children _ OrderedCollection new.
    guiObject _ self createToplevelWindow: label.
! !

"Blox extensions "
"Written by Brad Diller June 3, 1995"

BWindow subclass: #BTransientWindow	
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!BTransientWindow methodsFor: 'private'!!

Behavior defineCFunc: 'createTransientShell'
	 withSelectorArgs: 'createTransientShell: label in: parent'
	 forClass: BWindow
	 returning: #cObject	"could be more specific"
	 args: #(string cObject)
!

!BTransientWindow methodsFor: 'private'!

init: label in: parent
    children _ OrderedCollection new.
    guiObject _ self createTransientShell: label in: (parent getContainerObject).
! !

!BTransientWindow class methodsFor: 'instance creation'!

new: label in: parent
    ^super new init: label in: parent
! !


Blox subclass: #BDialog
       instanceVariableNames: 'children toplevel'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!BDialog methodsFor: 'private'!!

Behavior defineCFunc: 'createDialog'
	 withSelectorArgs: 'createDialog: parent label: aLabel prompt: aString'
	 forClass: BDialog class
	 returning: #cObject
	 args: #(cObject string string)
!

" !!! NOT YET IMPLEMENTED 
Behavior defineCFunc: 'getDialogBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BDialog
	     returning: #cObject
	     args: #(cObject)
!
"

Behavior defineCFunc: 'setDialogBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BDialog
	     returning: #void
	     args: #(cObject cObject)
!

Behavior defineCFunc: 'addDialogButton'
	     withSelectorArgs: 'addButton: guiObject label: aLabel receiver: anObject index: anInt'
	     forClass: BDialog
	     returning: #void
	     args: #(cObject string smalltalk int)
!

Behavior defineCFunc: 'addDialogButtonMessage'
	     withSelectorArgs: 'addButton: guiObject label: aLabel receiver: anObject message: aString'
	     forClass: BDialog
	     returning: #void
	     args: #(cObject string smalltalk string)
!

Behavior defineCFunc: 'dialogLoop'
	     withSelectorArgs: 'dialogLoop: dialog'
	     forClass: BDialog
	     returning: #void
	     args: #(cObject)
!

Behavior defineCFunc: 'getDialogText'
	     withSelectorArgs: 'getText: guiObject'
	     forClass: BDialog
	     returning: #string
	     args: #(cObject)
!

Blox defineSizeProtocol: 'Dialog' for: BDialog!
Blox defineMiscProtocol: 'Dialog' for: BDialog!


!BDialog class methodsFor: 'instance creation'!

new: parent label: aLabel prompt: aString
    ^super new init: parent label: aLabel prompt: aString
! !

!BDialog methodsFor: 'accessing'!

foregroundColor
    ^self shouldNotImplement
!

foregroundColor: color
    ^self shouldNotImplement
!!

!BDialog methodsFor: 'running'!

loop
	self dialogLoop: (self getContainerObject).
  toplevel destroy: (toplevel guiObject)
!!

!BDialog methodsFor: 'positioning'!

centerIn: view
	toplevel x: ((view x + ((view width)/ 2)) rounded ).
	toplevel y: ((view y + ((view height)/ 2)) rounded -  ((toplevel height / 2) rounded)).
!!

!BDialog methodsFor: 'private'!

init: parent label: aLabel prompt: aString
	toplevel := parent.
	guiObject _ BDialog createDialog: (parent getContainerObject) label: aLabel prompt: aString.

   children _ OrderedCollection new.
!!

Blox subclass: #BForm
       instanceVariableNames: 'children'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 

!BForm methodsFor: 'private'!!

Behavior defineCFunc: 'createForm'
	 withSelectorArgs: 'createForm: parent'
	 forClass: BForm class
	 returning: #cObject
	 args: #(cObject)
!

Behavior defineCFunc: 'getFormBackgroundColor'
	     withSelectorArgs: 'getBackground: guiObject'
	     forClass: BForm
	     returning: #cObject
	     args: #(cObject)
!


Behavior defineCFunc: 'setFormBackgroundColor'
	     withSelectorArgs: 'setBackground: guiObject color: aColor'
	     forClass: BForm
	     returning: #void
	     args: #(cObject cObject)
!

Blox defineSizeProtocol: 'Form' for: BForm!
Blox defineMiscProtocol: 'Form' for: BForm!


!BForm class methodsFor: 'instance creation'!

new: parent
    ^super new init: parent.
! !

!BForm methodsFor: 'accessing'!

foregroundColor
    ^self shouldNotImplement
!

foregroundColor: color
    ^self shouldNotImplement
!!

!BForm methodsFor: 'private'!

init: parent
    guiObject _ BForm createForm: parent getContainerObject.
    children _ OrderedCollection new.
! !

"Extensions to Blox Class"

Behavior defineCFunc: 'positionInForm'
	 withSelectorArgs: 'positionInForm: cObject fromHoriz: horiz fromVert: vert'
	 forClass: Blox
	 returning: #void
	 args: #(cObject cObject cObject)
! 

Behavior defineCFunc: 'getViewportObject'
	 withSelectorArgs: 'getViewportObject: cObject'
	 forClass: BList
	 returning: #cObject
	 args: #(cObject)
! 

!Blox methodsFor: 'accessing'!

getPositionObject
	^self getContainerObject.
!!

!BList methodsFor: 'accessing'!

getPositionObject
	^self getViewportObject: guiObject.
!!

!Blox methodsFor: 'positioning'!

posHoriz: sibling
	self positionInForm: (self getPositionObject) fromHoriz: (sibling getPositionObject) fromVert: nil.
! 

posVert: sibling
	self positionInForm: (self getPositionObject) fromHoriz: nil fromVert: (sibling getPositionObject).
!!

Object subclass: #Gui
  instanceVariableNames: 'blox cdata'
  classVariableNames: ''
  poolDictionaries: ''
  category: 'Graphics Windows'
!

! Gui methodsFor: 'accessing' !

blox
"Return blox which implements window"
	^blox.
!

blox: aBlox
	blox := aBlox. 
!!

! Gui methodsFor: 'private' !

alloc: size
"Dynamically allocate memory within Smalltalk. Create an instance of
ByteArray of size and add to set, cdata. When (self) is garbage
collected, data allocated and stored in self's private memory is also
garbage collected.  The central advantage of this method is that the
memory allocated for callbacks does not need to be explicitly managed
within C.  When the widget tied to self is destroyed, the memory
allocated for each Widget callback will be transparently released when
self is subsequently garbage collected"
| s |
    cdata isNil ifTrue: [ cdata := OrderedCollection new ].
    s := ByteArray new: size.
    cdata add: s.
    ^s
!!

Smalltalk snapshot!
