"File GuiData.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author        Date            Change
| bdiller       18 Sep 93       Created.
| bdiller       27 June 95      Replaced dependency mechanism with anonymous 
|                               notification mechanism.
|
"

!Object methodsFor: 'change management'!

changeState: anObject
    "log change"
    ^self notYetImplemented 
!

getCurrentState
    "default; override if necessary"
    ^self deepCopy
!

getStateChanges: viewState
    "compare self with viewState and return object describing differences"
    ^self notYetImplemented 
!!

Gui subclass: #GuiData
    instanceVariableNames: 'checkpoints'
    classVariableNames: ''
    poolDictionaries: ''
    category: ''
!

!GuiData methodsFor: 'change management'!

changeState: anObject
"Record the state change denoted by anObject"
    | updateCount|
    checkpoints isNil ifTrue: [checkpoints := Dictionary new].
    updateCount := checkpoints at: anObject ifAbsent: [0].
    checkpoints at: anObject put: (updateCount + 1) \\ 100.
!

checkpoints
    ^checkpoints.
!

getCurrentState
   ^checkpoints
!

getStateChanges: viewState
"Compare current state with viewState and return an object which describes
diffences"
| stateChanges subStateValue stateChange|
  stateChanges := Set new.
        (viewState isNil | checkpoints isNil) ifTrue: [^nil].
        viewState keysDo: [ :viewSubState | subStateValue := checkpoints at: viewSubState ifAbsent: [0].
          (subStateValue > ((viewState at: viewSubState) at: #counter))
                ifTrue: [ stateChange := Dictionary new. stateChange at: #state put: viewSubState. stateChange at: #counter put: subStateValue. stateChanges add: stateChange. ]
        ].
  ^stateChanges.
!!


