"File Menu.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author        Date            Change
| bdiller       1 Oct 93        Created.
"

Gui subclass:  #Menu
        instanceVariableNames: ''
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics Windows'
!

!Menu class methodsFor: 'initializing'!

new: view label: title
    | aMenu |
    aMenu := Menu new.
    aMenu blox: (BMenu new: (view blox) label: title).
    ^aMenu
!!

!Menu methodsFor: 'initializing'!

selectors: selectorsArray receiver: receiver argument: arg
    selectorsArray do: [:item | (item size >= 2 and: [(item at: 2) numArgs = 1] ) ifTrue: [item at: 3 put: arg]].
    blox callback: receiver using: selectorsArray. 
!!


Menu subclass:  #PopupMenu
        instanceVariableNames: ''
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics Windows'
!

!PopupMenu class methodsFor: 'initializing'!

new: view label: title
    | aMenu |
    aMenu := Menu new.
    aMenu blox: (BPopupMenu new: (view blox) label: title).
    ^aMenu.
!!


