"File Prompter.st
======================================================================
|
| Copyright (C) 1995 Free Software Foundation, Inc.
| Written by Brad Diller.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================
 

|     Change Log
| ============================================================================
| Author        Date            Change
| bdiller       18 Sep 93       Created.
"

Gui subclass:  #Prompter
        instanceVariableNames: 'defaultResponse'
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics Windows'
!

!Prompter class methodsFor: 'instance creation'!

message: aString default: aResponse in: view
    ^self new message: aString default: aResponse in: view
!

message: aString in: view
    ^self new message: aString default: '' in: view
!!

!Prompter methodsFor: 'initialize-delete'!

message: queryString default: aResponse in: view
| dialogShell  |
    "Prompt user for string input.  The default response, queryString, is displayed in
     text portion"
    defaultResponse := aResponse.
    dialogShell := BTransientWindow new: 'Prompter dialog' in: (view rootView blox).
    self blox: (BDialog new: dialogShell label: queryString prompt: aResponse).
    dialogShell createToplevelWindow: 'Prompter dialog'.
    blox addButton: (blox guiObject) label: 'OK' receiver: self message: #accept.
    blox addButton: (blox guiObject) label: 'Cancel' receiver: self message: #cancel.
    dialogShell map.
    "self blox centerIn: (view blox)."
    self blox loop.
!!

!Prompter methodsFor: 'accessing'!

accept 
| index |
"Truncate string after newline character"
    defaultResponse := blox getText: (blox guiObject).
		(index := defaultResponse findFirst: [ :ch | ch == Character nl ]) > 0
		    ifTrue: [ defaultResponse := defaultResponse copyFrom: 1 to: index - 1].
!

cancel
    defaultResponse := ''.
!

response
"Return default response"
    ^defaultResponse
!!

