"
|     Change Log
| ============================================================================
| Author       Date       Change 
"
"
     GDBM_FILE gdbm_open(name, block_size, flags, mode, fatal_func);
     void gdbm_close(dbf);
     int gdbm_store(dbf, key, content, flag);
     datum gdbm_fetch(dbf, key);
     int gdbm_delete(dbf, key);
     datum gdbm_firstkey(dbf);
     datum gdbm_nextkey(dbf, key);
     int gdbm_reorganize(dbf);
     void gdbm_sync(dbf); -- new
     int gdbm_exists(dbf, key); not present
     char *gdbm_strerror(errno); -- new 
     int gdbm_setopt(dbf, option, value, size) -- new
"


CObject variableWordSubclass: #GDBM
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GDBM access'
!
    
"
typedef struct {
	char *dptr;
	int   dsize;
      } datum;
"


CStruct newStruct: #DatumStruct
	declaration:
	    #(
	      (dPtr (ptr char))
	      (dSize long)
	     )
!

!DatumStruct class methodsFor: 'instance creation'!

fromString: aString
    | obj strObj len |
    obj _ self new.
    len _ aString size.
    obj dSize value: len.
    obj dPtr at: 0 put: aString type: CString scalarIndex.
    ^obj
! !


!DatumStruct methodsFor: 'accessing'!

asString
    | len str |
    len _ self dSize value.
    str _ String new: len.
    1 to: len do: 
	[ :i | str at: i put: (self dPtr at: i - 1 ) ].
    ^str
! !



Behavior defineCFunc: 'gdbm_open'
	 withSelectorArgs: 'open: fileName blockSize: size flags: flags
                            mode: modeInt fatalFunc: funcAddr'
	 forClass: GDBM class
	 returning: (CType baseType: GDBM)
	 args: #(string int int int cObject)
!

'foo' printNl!

Behavior defineCFunc: 'gdbm_close'
	 withSelectorArgs: 'close'
	 forClass: GDBM
	 returning: #int
	 args: #(self)
!


Behavior defineCFunc: 'gdbm_store'
	 withSelectorArgs: 'at: key put: value flag: aFlag' 
	 forClass: GDBM
	 returning: #int
	 args: #(self cObject cObject int)
!

'bar ' printNl!

DatumStruct inspect!

Behavior defineCFunc: 'gdbm_fetch'
	 withSelectorArgs: 'at: key' 
	 forClass: GDBM
	 returning: (CType baseType: DatumStruct)
	 args: #(self cObject)
!

'bar2 ' printNl!

Behavior defineCFunc: 'gdbm_delete'
	 withSelectorArgs: 'removeKey: key' 
	 forClass: GDBM
	 returning: #long
	 args: #(self cObject)
!

'bar3 ' printNl!

Behavior defineCFunc: 'gdbm_firstkey'
	 withSelectorArgs: 'firstKey' 
	 forClass: GDBM
	 returning: (CType baseType: DatumStruct)
	 args: #(self)
!

'bar4 ' printNl!

Behavior defineCFunc: 'gdbm_nextkey'
	 withSelectorArgs: 'nextKey: afterDatum' 
	 forClass: GDBM
	 returning: (CType baseType: DatumStruct)
	 args: #(self cObject)
!

Behavior defineCFunc: 'gdbm_reorganize'
	 withSelectorArgs: 'reorganize'
	 forClass: GDBM
	 returning: #long
	 args: #(self)
!

!GDBM class methodsFor: 'testing'!

test
    | database key value |
    database _ self open: 'test.gdbm' blockSize: 1024 flags: 2 "write/create"
		    mode: 8r666 fatalFunc: nil.
    database inspect.
    key _ DatumStruct fromString: 'fred'.
    key inspect.
    value _ DatumStruct fromString: 'Fred Flintstone'.
    value inspect.
    (database at: key put: value flag: 1 "replace") printNl.
    key _ DatumStruct fromString: 'wilma'.
    value _ DatumStruct fromString: 'Wilma Flintstone'.
    (database at: key put: value flag: 1 "replace") printNl.
    database close.
    database _ self open: 'test.gdbm' blockSize: 1024 flags: 0 "read"
		    mode: 8r666 fatalFunc: nil.
    (database at: (DatumStruct fromString: 'barney')) dPtr inspect.
    
    (database at: (DatumStruct fromString: 'wilma')) inspect.
    database close.
!

test2
    | database item value |
    database _ self open: 'test.gdbm' blockSize: 1024 flags: 0 "read"
		    mode: 8r666 fatalFunc: nil.

    item _ database firstKey.
    [ item dPtr value notNil ] 
	whileTrue: 
	    [ value _ database at: item.
	      stdout nextPutAll: item asString;
		  nextPutAll: '  ';
		  nextPutAll: value asString;
		  nl.
	      item _ database nextKey: item ].
    database close.

!

test3
    "The big one"
    | database key value item |
    database _ self open: 'st.gdbm' blockSize: 1024 flags: 2 "write/create"
		    mode: 8r666 fatalFunc: nil.

    Object withAllSubclasses do:
	[ :subclass | 
    
    database close.

    database _ self open: 'st.gdbm' blockSize: 1024 flags: 0 "read"
		    mode: 8r666 fatalFunc: nil.
    
    
    item _ database firstKey.
    [ item dPtr value notNil ] 
	whileTrue: 
	    [ value _ database at: item.
	      stdout nextPutAll: item asString;
		  nextPutAll: '  ';
		  nextPutAll: value asString;
		  nl.
	      item _ database nextKey: item ].
    database close.


! !

GDBM test
!

GDBM test2
!



