"======================================================================
|
|   C indented printer (?)
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:54:50 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"

FileStream fileIn: 'IndentedStream.st'!

IndentedStream subclass: #CStream
       instanceVariableNames: ''
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
!

CStream comment: '
I emit indented C code.  The model that I have is that most of my 
operations emit things without the newline, leaving the newline and
consequently the indenting policy up to a few routines which make
all the indentation decisions.' !

!CStream methodsFor: 'accessing'!

emitBlock: aBlock
    self openBrace.
    aBlock value.
    self closeBrace.
!


emitIf: expr then: aBlock
    self emitIfHeader: expr then: aBlock.
    self closeBrace.
!

emitIfHeader: expr then: aBlock
    self nextPutAll: 'if ('; nextPutAll: expr; nextPutAll: ') '.
    self openBrace.
    aBlock value.
!	

emitDecl: type var: var
    self nextPutAll: type; tabTo: 20; nextPutAll: var; nextPut: $;.
!

emitStmt: stmt
    self nextPutAll: stmt; nextPut: $; .
!

emitLineComment: text
    self tabTo: 40; emitComment: text.
!

emitComment: text
    self nextPutAll: '/* '; nextPutAll: text; nextPutAll: ' */'.
!

openBrace
    self nextPut: ${; nl.
    self pushLevel.
!

closeBrace
    self popLevel.
    self nextPut: $}; nl.
! !

"
| s |
    s _ CStream on: stdout.
    s emitBlock: 
        [ s emitDecl: 'int' var: 'foo'; nl; nl.
    
	  s emitIf: 'foo > 3' then: 
	      [ s emitStmt: 'foo++'; nl.
		s emitIf: 'foo < 5' then:
		    [ s emitStmt: 'foo <<= 2'; nl.
                      s emitIf: 'foo & 0xff' then: [
                         s emitStmt: 'foo *= 5'; nl.
                         ].
                    ].
                s emitStmt: 'foo = sin(foo)'; 
                 emitLineComment: 'perhaps a bit unrealistic'; nl.
	      ].
        ].
!
"
    
    
"

| s t |
    s _ IndentedStream on: (t _ String new: 0).
    s pushLevel.
    s nl.
    s nextPutAll: 'hello there you rabbit'.
    s nl.
    s contents printNl.
!

"
