/***********************************************************************
 *
 *	System specific module declarations
 *
 *	$Revision: 1.5 $
 *	$Date: 1995/09/17 10:49:48 $
 *	$Author: sbb $
 *
 ***********************************************************************/

/***********************************************************************
 *
 * Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
 * Written by Steve Byrne.
 *
 * This file is part of GNU Smalltalk.
 *
 * GNU Smalltalk is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later 
 * version.
 * 
 * GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
 * Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
 *
 ***********************************************************************/


/*
 *    Change Log
 * ============================================================================
 * Author      Date       Change 
 * sbb	     14 Sep 95	  Added openPipe, closePipe, getOpenFileSize.
 *
 * sbb	     23 Jun 95	  Switched to GST header guard prefix.
 *
 * sbyrne    16 May 90	  Created.
 *
 */

#ifndef __GSTSYSDEP__
#define __GSTSYSDEP__


#include <stdio.h>

#ifndef INTERRUPT_STATE_TYPE
#define INTERRUPT_STATE_TYPE	int
#endif

typedef INTERRUPT_STATE_TYPE	IntState;

extern IntState		disableInterrupts();
extern void		enableInterrupts(), signalAfter(), setSignalHandler(),
			initSysdep();
extern unsigned long	getMilliTime(), getTime(), getFileModifyTime();
extern char		*getFullFileName(), *getCurDirName();
extern mst_Boolean	fileIsReadable();
extern FILE		*openPipe();
extern int		closePipe();
extern OOP		getOpenFileSize();

#endif /* __GSTSYSDEP__ */
