
STObject subclass: #ClassEditor
		 instanceVariableNames: 'panel scrolledText fieldMatrix actionMatrix'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

ClassEditor comment: 'I control a simple panel that popups when a class is edited
or being create.  I then update the system with the new class info.' !

!ClassEditor methodsFor: 'Initialization'!

init
	| rect |
	super init.
	rect _ Rect alloc initFromX: 500.0 y: 600.0 width: 400.0 height: 200.0.
	self initPanel: rect.
	self initText: rect.
	self initActionMatrix: rect.
	self compose.
!

initPanel: rect
	panel _ Panel alloc initContent: (rect asCPointer)
				style: 1
				backing: 2
				buttonMask: 1
				defer: YES.
	panel setTitle: 'Class Editor'.
!

initText: aRect
	| bounds font |
	bounds _ Rect alloc initFromRect: (aRect asCPointer).
	bounds setX: 10.0; setY: 40.0; setHeight: ((aRect height) - 45.0); setWidth: ((aRect width) - 20.0).
	scrolledText _ TextScrollView alloc initFrame: bounds.
	font _ Font newFont: 'Ohlfs' size: 10.0.
	(scrolledText text) setFont: (font id).
!

initActionMatrix: rect
	| bounds size |
	
	bounds _ Rect alloc initFromRect: (rect asCPointer).
	size _ Size alloc init.
	bounds setX: ((rect width) - 140.0); setY: 5.0 ; setHeight: 28.0 ; setWidth: 120.0.	
	
	actionMatrix _ Matrix alloc initFrame: (bounds asCPointer)
							mode: 0							"NX_LISTMODE"
							cellClass: (ButtonCell isa)
							numRows: 1
							numCols: 2.
	actionMatrix setAutosizeCells: YES.
	actionMatrix setIntercell: (size asCPointer).
	actionMatrix setTitle: 'Cancel' at: 0 anArg: 0.
	actionMatrix setTitle: 'Ok' at: 0 anArg: 1.

	actionMatrix setAction: (OCInterface getUid: 'action1:').
	actionMatrix setTarget: self id.
!

compose
	| contentView |
	contentView _ panel contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.

	"contentView addSubview: fieldMatrix id."
	contentView addSubview: scrolledText id.	
	contentView addSubview: actionMatrix id.
!!

!ClassEditor methodsFor: 'Display'!

orderFront
	panel makeKeyAndOrderFront: panel id.
	panel contentView display.
!!

!ClassEditor methodsFor: 'Class Editing'!

editClass: aClass
    | stream class name supername|
    
    aClass isNil 
		ifTrue: [ ^nil ].
    
	class _ aClass.

    supername _ class superclass name.		"Handle the nil case"
    name _ class name.						"handle the nil case"

    stream _ WriteStream on: (String new: 50).
    stream nextPutAll: supername;
		space;
		nextPutAll: class kindOfSubclass;
		nextPut: $#;
		nextPutAll: name; 
		nl.

    stream nextPutAll: '    instanceVariableNames: '''.
	class instVarNames do: [ :name | stream nextPutAll: name; space. ].
    stream nextPut: $'; nl.
    stream nextPutAll: '    classVariableNames: '''.
    class classVarNames do: [ :name | stream nextPutAll: name; space. ].
    stream nextPut: $'; nl.
    stream nextPutAll: '    poolDictionaries: '''.
    stream nextPut: $'; nl.
    stream nextPutAll: '    category: '''.
    stream print: class category; nextPut: $'; nl.
	scrolledText text setText: (stream contents).
	self orderFront
!!

!ClassEditor methodsFor: 'Class Creation'!

createSubclassOf: aClass
	| stream |
    stream _ WriteStream on: (String new: 0).
	stream nextPutAll:'
 ';
			nextPutAll: (aClass name), ' subclass: #My', (aClass name);
			nextPutAll: '
	instanceVariableNames: '' ''
	classVariableNames: '' ''
	poolDictionaries: '' ''
	category: nil'.  
	scrolledText text setText: (stream contents).
	self orderFront
!!

!ClassEditor methodsFor: 'ACtion'!

action1: sender
	| matrix tag text code len |
	matrix _ Matrix newFromId: sender.
	tag _ matrix selectedCol.
	tag == 0
		ifTrue: [ panel performClose: nil. ].
	tag == 1
		ifTrue: [
			text _ scrolledText text.
			len _ text textLength.
			code _ String new: (len + 1).
			text getSubstring: code start: 0 length: len.
   			code _ 'ObjectdoItMethod ^[ ', code, ' ] value'.
			Object compileString: code ifError: [ 'error' printNl. ^self].
			nil ObjectdoItMethod.
			panel performClose: nil ].
!!