STObject subclass: #ConsoleController
		 instanceVariableNames: 'panel scrolledText'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

ConsoleController comment: 'Controls the display of out from interpreter'!

!ConsoleController methodsFor: 'Hacking'!

makeConsoleGlobal
	" 
	This is used that Object's print can be redirected
	to the workspace instead of going out stdout 
	"
	Smalltalk at: #Console put: self
!

replaceObjectsPrint
	"
	This methods replaces Object print
	"

	Object compile:'
print
	| stream text |
	text _ Console text.
    stream _ WriteStream on: (String new: 0).
	self printOn: stream.
	text appendText: stream contents.
	text display.'.

	Object compile:'
error: message
	message printNl.'.

!!

!ConsoleController methodsFor: 'Initialization'!

init
	" Console will be a global varialbe where all error messages and
	  print, printNl will go to "
	| rect |
	rect := Rect alloc initFromX: 400.0 y: 410.0 width: 400.0 height: 300.0.
	super init.
	self initPanel: rect.
	rect setX: 0.0.
	rect setY: 0.0.
	self initTextScrollView: rect.
	self compose.
	
	self makeConsoleGlobal.
	self replaceObjectsPrint.
!

initPanel: rect
	panel := Window alloc initContent: (rect asCPointer)
								style: 6
							  backing: 2
						   buttonMask: (4 bitOr: 1)
								defer: YES.
	panel setTitle: 'Console'.
!

compose
	| contentView |
	contentView := panel contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.
	contentView addSubview: scrolledText id.
	contentView display.
!

initTextScrollView: rect
	scrolledText := TextScrollView alloc initFrame: rect.
	scrolledText setBorderType: 0.
!!

!ConsoleController methodsFor: 'Accessing'!

text
	^(scrolledText text)
!

panel 
	^panel
!!

