" ========================================================================================
	This is so that when we get the text, by reference, from a Text Object smalltalk
	actually lets us keep the string.  If the third parameter what not of stringOut type
	then we would not get the string.  Make sure the string passed in to this function 
	is large enought to hold the value.
 ======================================================================================== "
Behavior defineCFunc: 'msgSend'
		withSelectorArgs: 'intMsgSend3: anId sel: aSelector argstring: arg0 argint: arg1 argint: arg2'
		forClass: OCInterface class
		returning: #int
		args: #(cObject cObject stringOut int int)
!
" ========================================================================================
	This overrides STObject's normal setOOP auto generated callout so that arg0 is passed
	as of type smalltalk, this means that when it reaches C code (or Objective-C) it will
	be seen as of type OOP and we can send messages to it using the gnu smalltalk function
	msgSend.
 ======================================================================================== "
!STObject methodsFor: 'Fixing'!

setOOP: arg0 
        | anId aSelector rValue | 
        anId _ id.
        aSelector _ OCInterface getUid: 'setOOP:'.

		Behavior defineCFunc: 'msgSend'
			withSelectorArgs: 'cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0'
			forClass: OCInterface class
			returning: #cObject
			args: #(cObject cObject smalltalk).
			
        rValue _ OCInterface cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0.
        ((OCInterface id: id equalTo: rValue) = 1)
                ifTrue: [ ^self ]
                ifFalse: [ ^OCObject newFromId: rValue. ].
!

init
	super init.
	self setOOP: self.
!!
" ========================================================================================
	Same as above. 
 ======================================================================================== "
!STView methodsFor: 'Fixing'!

setOOP: arg0 
        | anId aSelector rValue | 
        anId _ id.
        aSelector _ OCInterface getUid: 'setOOP:'.

		Behavior defineCFunc: 'msgSend'
			withSelectorArgs: 'cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0'
			forClass: OCInterface class
			returning: #cObject
			args: #(cObject cObject smalltalk).
			
        rValue _ OCInterface cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0.
        ((OCInterface id: id equalTo: rValue) = 1)
                ifTrue: [ ^self ]
                ifFalse: [ ^OCObject newFromId: rValue. ].
!

initFrame: rect
	super initFrame: rect.
	self setOOP: self.
!!
" ========================================================================================
	These categories add the ability of classes to file themselves out with there class
	definition.
 ======================================================================================== "
!ClassDescription methodsFor: 'filing'!

fileOutCategory: categoryName on: aFileStream
    self emitCategory: categoryName toStream: aFileStream.
!

newFileOutOn: aFileStream
	" 
	  This method should only be invoked on classes and not
	  meta classes.  For instance 
	  		CObject newFileOutOn: aStream
	  is acceptable but
	  		CObject class newFileOutOn: aStream
	  is not 
	"  
    | categories now |
	
    aFileStream nextPutAll: '''Filed out from ';
		nextPutAll: Version;
		nextPutAll: ' on '.
    now _ Date dateAndTimeNow.
    aFileStream print: (now at: 1);
		nextPutAll:  '  ';
		print: (now at: 2);
		nextPutAll: ' GMT''!'; nl; nl.

	" Print class description "
	
	self fileOutClassDescritionOn: aFileStream.
	self fileOutCommentOn: aFileStream.

	" File out class method first "
	
	self class notNil
		ifTrue: [ self class fileOutOn: aFileStream ].

    methodDictionary isNil 
		ifTrue: [ ^self ].
	
    categories _ Set new.
    methodDictionary do:
		[ :method | categories add: (method methodCategory) ].

    categories asSortedCollection do:
        [ :category | self emitCategory: category toStream: aFileStream ]

!

fileOutClassDescritionOn: aFileStream
    | class name supername|
    
	class _ self.

    supername _ class superclass name.		"Handle the nil case"
    name _ class name.						"handle the nil case"

    aFileStream nextPutAll: supername; space;
		nextPutAll: class kindOfSubclass;
		nextPut: $#;
		nextPutAll: name; 
		nl.

    aFileStream nextPutAll: '    instanceVariableNames: '''.
	class instVarNames do: [ :name | aFileStream nextPutAll: name; space. ].
    aFileStream nextPut: $'; nl.
    aFileStream nextPutAll: '    classVariableNames: '''.
    class classVarNames do: [ :name | aFileStream nextPutAll: name; space. ].
    aFileStream nextPut: $'; nl.
    aFileStream nextPutAll: '    poolDictionaries: '''.
    aFileStream nextPut: $'; nl.
    aFileStream nextPutAll: '    category: '.
    aFileStream print: class category; nl.
	aFileStream nextPutAll:'!'; nl ; nl.
!

fileOutCommentOn: aFileStream
	| name comment |
	" Self had better be a class and not an instance or
	  we are in trouble. "
	name := self name.
	comment := self comment.
	comment notNil
		ifTrue: [ aFileStream nextPutAll: name, ' comment: ''', comment, '''!'; nl ; nl. ]
!!

" ========================================================================================
	These new methods are used to find the categories and the methods within those 
	categories for classes.
 ======================================================================================== "
!Behavior methodsFor: 'Category Info'!

categories
	" Returns a set with all the categories we have "
	| methodDict categories |
	categories _ Set new.
	methodDict _ self methodDictionary.
	methodDict notNil
		ifTrue: [ methodDict do: [ :aMethod | categories add: (aMethod methodCategory) ]. ].
	^categories
!

selectorsIn: aCategory
	" Returns a set of all selectors in a category of self "
	| methodDict selectors selectorsInCategory |
	selectorsInCategory _ Set new.
	methodDict _ self methodDictionary.
	selectors _ self selectors.
	
	methodDict notNil
		ifTrue: [
			selectors do: [ :sel | 					
				(((methodDict at: sel) methodCategory) = aCategory) 
					ifTrue: [ selectorsInCategory add: sel ] ] ] .
	^selectorsInCategory
!!
" ========================================================================================
	A little hack to support appending text to a text object.
 ======================================================================================== "
!Text methodsFor: 'Appending'!

appendText: aString
	| len |
	len _ self textLength.
	len == 0
		ifTrue: [ self setText: aString ]
		ifFalse: [ self setSel: len anArg: len; replaceSel: aString ].
	self scrollSelToVisible.
!!
" ========================================================================================
	Some define like stuff.  Eventually will make a seperate file with as much these
	constant definition as necesarry to make nice programs.
 ======================================================================================== "
Smalltalk at:#YES put: (1 asCharacter)!
Smalltalk at:#NO put: (0 asCharacter)!
" ========================================================================================
	Event Defines
 ======================================================================================== "
Smalltalk at: #MOUSEDRAGGEDMASK put: (1 bitShift: 6)!
Smalltalk at: #MOUSEUPMASK put: (1 bitShift: 2)!
Smalltalk at: #MOUSEUP put: 2!
