'Filed out from Smalltalk version 1.2.alpha3 on 27-Jul-95  7:44:34 GMT'!

STObject subclass: #ObjectInspector
    instanceVariableNames: 'window winDelegate scrolledText splitView box ivarBrowser ivarBrowserDelegate ivarNames ivars '
    classVariableNames: 'isa '
    poolDictionaries: ''
    category: nil
!

ObjectInspector comment: 'Sherlock Holmes at your disposal' !

!ObjectInspector methodsFor: 'Action'!

action1: sender
    | index ivar matrix col |
	col _ ivarBrowser selectedColumn.
	matrix _ ivarBrowser matrixInColumn: col.
	index _ matrix selectedRow.

	ivar _ ivars at: index + 1.
	ivar notNil
		ifTrue: [ scrolledText text setText: ivar printString ]
		ifFalse: [ scrolledText text setText: 'nil' ]
!

doubleAction1: sender
    | index ivar matrix col |
	col _ ivarBrowser selectedColumn.
	matrix _ ivarBrowser matrixInColumn: col.
	index _ matrix selectedRow.

	ivar _ ivars at: index + 1.
	ivar notNil
		ifTrue: [ ivar guiInspect ]
!!

!ObjectInspector methodsFor: 'Freeing'!

free
	" Since I don't know the mechanism by which smalltalk free
	  objects I will free stuff explicitly whenever certain
	  windows are closed. "
	'Freeing an object inspector' printNl.
	scrolledText free.
	ivarBrowser free.
	ivarBrowserDelegate free.
	splitView free.
	box free.
	"window free."
	super free.
!!

!ObjectInspector methodsFor: 'Inspecting'!

buildIvarCollectionFor: object
    | class numInstVars numIndexVars totalVars |

    class _ object class.
    
    numIndexVars _ object basicSize. "scale this "
    numInstVars _ class instSize.
    totalVars _ numIndexVars + numInstVars.

    ivarNames _ OrderedCollection new: totalVars + 1.
    ivarNames add: #self.

    numInstVars > 0
		ifTrue: [ ivarNames addAllLast: class allInstVarNames. ].
    
    1 to: numIndexVars do:
		[ :i | ivarNames add: i printString ].

    ivars _ OrderedCollection new: totalVars + 1.
    ivars add: object.
    2 to: totalVars + 1 do:
		[ :i | ivars add: (object instVarAt: i - 1) ].
!

inspect: object
	| name |
	
	name _ object class name.
    	name isNil 
		ifTrue: [ name _ object name, ' class' ].

	self buildIvarCollectionFor: object.
	ivarBrowserDelegate collection: ivarNames.
	ivarBrowser loadColumnZero.

	window setTitle: 'Inspecting ', name.
	window makeKeyAndOrderFront: nil.
!!

!ObjectInspector methodsFor: 'Interface'!

createWindow: rect
	window _ Window alloc initContent: (rect asCPointer)
			style: 6
			backing: 2
			buttonMask: (4 bitOr: 1)
			defer: YES.

	window setTitle: 'Object Inspector '.

    	winDelegate _ FreeOwnerWindowDelegate alloc init.
	winDelegate owner: self.
	window setDelegate: winDelegate id.
!

createBrowser: rect
	ivarBrowser _ NXBrowser alloc initFrame: (rect asCPointer).
	ivarBrowserDelegate _ CollectionBrowserDelegate alloc init.
	ivarBrowserDelegate title: 'Ivars'.
	ivarBrowser setDelegate: (ivarBrowserDelegate id).
	ivarBrowser setTarget: (self id).
	ivarBrowser setAction: (OCInterface getUid: 'action1:').
	ivarBrowser setDoubleAction: (OCInterface getUid: 'doubleAction1:').
	ivarBrowser setEmptySelectionEnabled: NO.
	ivarBrowser setHorizontalScrollButtonsEnabled: NO.
	ivarBrowser setHorizontalScrollerEnabled: NO.
	ivarBrowser setMaxVisibleColumns: 1.
	ivarBrowser loadColumnZero.
!

createText: rect
	| font darkGreen |
	scrolledText _ TextScrollView alloc initFrame: rect.
	font _ Font newFont: 'Ohlfs' size: 10.0.
	(scrolledText text) setMonoFont: YES.
	(scrolledText text) setFont: (font id).

	darkGreen _ Color alloc init.
	darkGreen setRedComponent: ( 51.0 / 255.0 ).
	darkGreen setGreenComponent: ( 119.0 / 255.0 ).
	darkGreen setBlueComponent: ( 68.0 / 255.0 ).
	scrolledText setBackgroundColor: darkGreen.!

init
	| rect |
	rect _ Rect alloc initFromX: 400.0 y: 200.0 width: 200.0 height: 300.0.

	super init.
	self createWindow: rect.
	self createBrowser: rect.
	self createText: rect.
	self createSV: rect.
	self compose.
!

compose
	| contentView |
	" Arranges everything on screen so that it looks nice "
	
	contentView _ window contentView.
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.

	splitView addSubview: ivarBrowser id.
	splitView addSubview: scrolledText id.

	contentView addSubview: box id.
	"contentView display."
!

createSV: rect
	| bounds contentView size |
	bounds _ Rect alloc initFromRect: rect asCPointer.	
	bounds setX: 0.0 ; setY: 0.0.
	
	box _ Box alloc initFrame: (bounds asCPointer).
	box notifyAncestorWhenFrameChanged: YES.
	box setAutoresizeSubviews: YES.
	box setAutosizing: (2 bitOr:8; bitOr: 16).
	box setTitlePosition: 0.		" 0 = No Title "
	box setBorderType: 0.			" 0 = No Border "

	splitView _ NXSplitView alloc initFrame: (rect asCPointer).
	splitView notifyAncestorWhenFrameChanged: YES.
	splitView setAutoresizeSubviews: YES.
	splitView setAutosizing: (2 bitOr:8; bitOr: 16).
	
	box setContentView: (splitView id).
!!

