
STObject subclass: #WorkspaceController
		 instanceVariableNames: 'panel scrolledText evalButton resultButton'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

WorkspaceController comment: 'Controls a panel for entering smalltalk code and
evaluatin it' !

!WorkspaceController methodsFor: 'Initialization'!

init
	" Console will be a global varialbe where all error messages and
	  print, printNl will go to "
	| rect size contentView |

	rect _ Rect alloc initFromX: 500.0 y: 100.0 width: 400.0 height: 300.0.

	super init.
	self initPanel: rect.
	contentView _ panel contentView.
	contentView getBounds: (rect asCPointer).
	contentView notifyAncestorWhenFrameChanged: YES.
	contentView setAutoresizeSubviews: YES.
	rect setHeight: ((rect height) - 60.0).
	self initTextScrollView: rect.
	rect setY: (rect height); setHeight: 60.0.
	self initButton: rect.
	contentView addSubview: scrolledText id.
	contentView addSubview: evalButton id.
!

initPanel: rect
	panel _ Window alloc initContent: (rect asCPointer)
								style: 6
							  backing: 2
						   buttonMask: (4 bitOr: 1)
								defer: YES.
	panel setTitle: 'Workspace'.
!

initButton: rect
	evalButton _ Button alloc initFrame: (rect asCPointer).
	evalButton setTitle: 'Evaluate contents'.
	evalButton setImage: ((NXImage findImageNamed: 'browser/Eval.tiff') id).
	evalButton setIconPosition: 2. 				"NX_ICONLEFT"
	evalButton setTarget: (self id).
	evalButton setAction: (OCInterface getUid: 'action1:').
	evalButton setAutosizing: (2 bitOr: 8).		" NX_WIDTHSIZABLE | NX_MAXYMARGINSIZABLE "
!

initTextScrollView: rect
	| font |
	scrolledText _ TextScrollView alloc initFrame: rect.
	scrolledText setAutosizing: ((8 bitOr: 16) bitOr: 2).	" NX_WIDTHSIZABLE | NX_HEIGHTSIZABLE | NX_MINYMARGINSIZABLE"
	font _ Font newFont: 'Ohlfs' size: 10.0.
	(scrolledText text) setMonoFont: YES.
	(scrolledText text) setFont: (font id).
	scrolledText setBorderType: 0.
!!


!WorkspaceController methodsFor: 'accessing'!

panel	
	^panel
!!

!WorkspaceController methodsFor: 'Target Action'!

action1: sender
	self evaluateContents.
!!

!WorkspaceController methodsFor: 'Evaluating Code'!

evaluateContents
	" Takes the contents of the workspaces text object and
	  compiles them into objects method executeStatements
	  and then executes it.  The result in shown is appended
	  to the text object. "
	| code len codeStream result text |
	text _ scrolledText text.
	len _ text textLength.
	code _ String new: (len + 1).  	
	text getSubstring: code start: 0 length: len.
	codeStream _ WriteStream on: (String new: 20).
	codeStream nextPutAll: 'executeStatements
	'; 
		nextPutAll: code.	
	Object class compile: (codeStream contents).
	codeStream emptyStream.
	result _ Object executeStatements.
	result printOn: codeStream.
"
	text appendText: '
-- Result --
'.
	text appendText: (codeStream contents).
"
!!

