
#import <appkit/appkit.h>
#import "Point.h"
#import "Size.h"

@interface Rect : Object
{
	NXRect	rect;
}

- initFromX:(float)x y:(float)y width:(float)width height:(float)height;
- initFromOrigin:(NXPoint *)p size:(NXSize *)s;
- initFromRect:(NXRect *)aRect;

- setRect:(NXRect *)aRect;

- (NXRect *)asCPointer;
- setOrigin: aPoint;
- origin;
- setX:(float)x;
- setY:(float)y;
- (double)xCoord;
- (double)yCoord;
- setSize:aSize;
- size;
- setWidth:(float)width;
- setHeight:(float)height;
- (double)width;
- (double)height;
- (double)area;
- (Rect *)intersectionWith:(Rect *)r;
- (Rect *)unionWith:(Rect *)r;
- intergral;
- insetBy:(Size *)size;
- offsetBy:(Size *)size;


// Test graphic relations

- (BOOL)mouseIn:(Point *)p flipped:(BOOL)aBool;
- (BOOL)pointIn:(Point *)p;
- (BOOL)intersects:(Rect *)r;
- (BOOL)contains:(Rect *)r;
- (BOOL)equals:(Rect *)r;
- (BOOL)isEmpty;

// appkit drawing

- clip;
- fill;
- erase;
- highlight;
- drawButton:(Rect *)clipRect;
- drawGrayBezel:(Rect *)clipRect;
- drawGroove:(Rect *)clipRect;
- drawWhiteBezel:(Rect *)clipRect;
- drawFrame;
- drawFrameWithWidth:(float)width;

@end
