"
| ============================================================================
| ============================================================================
"

!STObject methodsFor: 'Fixing'!

setOOP: arg0 
        | anId aSelector rValue | 
        anId _ id.
        aSelector _ OCInterface getUid: 'setOOP:'.

		Behavior defineCFunc: 'msgSend'
			withSelectorArgs: 'cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0'
			forClass: OCInterface class
			returning: #cObject
			args: #(cObject cObject smalltalk).
			
        rValue _ OCInterface cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0.
        ((OCInterface id: id equalTo: rValue) = 1)
                ifTrue: [ ^self ]
                ifFalse: [ ^OCObject newFromId: rValue. ].
!

init
	super init.
	self setOOP: self.
!!

!STView methodsFor: 'Fixing'!

setOOP: arg0 
        | anId aSelector rValue | 
        anId _ id.
        aSelector _ OCInterface getUid: 'setOOP:'.

		Behavior defineCFunc: 'msgSend'
			withSelectorArgs: 'cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0'
			forClass: OCInterface class
			returning: #cObject
			args: #(cObject cObject smalltalk).
			
        rValue _ OCInterface cObjectMsgSend1: anId sel: aSelector argSmalltalk: arg0.
        ((OCInterface id: id equalTo: rValue) = 1)
                ifTrue: [ ^self ]
                ifFalse: [ ^OCObject newFromId: rValue. ].
!

initFrame: rect
	super initFrame: rect.
	self setOOP: self.
!!

Smalltalk at:#YES put: (1 asCharacter)!
Smalltalk at:#NO put: (0 asCharacter)!


"
| ============================================================================
"
Smalltalk at: #MOUSEDRAGGEDMASK put: (1 bitShift: 6)!
Smalltalk at: #MOUSEUPMASK put: (1 bitShift: 2)!
Smalltalk at: #MOUSEUP put: 2!

STView subclass: #SimpleView
		 instanceVariableNames: 'lineColor bgColor titleColor startPoint endPoint'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

!SimpleView methodsFor: 'Initialization'!

initFrame: rect
	super initFrame: rect.

	self notifyAncestorWhenFrameChanged: YES.
	
	lineColor := Color alloc init.
	lineColor setRedComponent: 0.1.
	lineColor setGreenComponent: 0.2.
	lineColor setBlueComponent: 0.3.

	bgColor := Color alloc init.
	bgColor setRedComponent: 0.4.
	bgColor setGreenComponent: 0.6.
	bgColor setBlueComponent: 0.7.

	titleColor := Color alloc init.
	titleColor setRedComponent: 0.0.
	titleColor setGreenComponent: 0.1.
	titleColor setBlueComponent: 0.2.

	startPoint := Point alloc init.
	endPoint := Point alloc init.
!!


!SimpleView methodsFor: 'Drawing'!

drawSelf: rect anArg: rectCount
	| bounds title |

	bounds := Rect alloc initFromRect: rect.	
	title := Rect alloc initFromRect: rect.	

	bgColor setColor.
	bounds fill.

	lineColor setColor.
	DPS moveTo: (startPoint asCPointer).
	DPS lineTo: (endPoint asCPointer).
	DPS stroke.

	title setY: ((bounds yCoord) + (bounds height) - 10.0).
	title setHeight: 10.0.
	titleColor setColor.
	title fill.

	bounds drawFrame.
	bounds free.
	title free.
!!

!SimpleView methodsFor: 'Event handling'!

mouseDown: event
	| e p w oldMask app bounds newP |

	app _ Application new.
	e := MouseEvent alloc initFromEvent: event.
	p := Point alloc init.	
	newP := Point alloc init.	
	bounds := Rect alloc init.
	
	" Set up the window event mask "
	
	w := self window.
	oldMask := w addToEventMask: ( MOUSEDRAGGEDMASK bitOr: MOUSEUPMASK ).

	" Get the location of the mouse down and convert it to make
	  sense in our view "
	  
	e location: newP asCPointer.
	self convertPoint: (newP asCPointer) fromView: nil.
	startPoint setX: (newP xCoord) y: (newP yCoord).
	
	" Loop waiting for a mouse up event "
	p setX: (newP xCoord) ; setY: (newP yCoord).
	
	[(e type) = MOUSEUP]
		whileFalse: [
		
			e setEvent: ( app getNextEvent: ( MOUSEDRAGGEDMASK bitOr: MOUSEUPMASK ) ).
			e location: (newP asCPointer).
			self convertPoint: (newP asCPointer) fromView: nil. 

			self getBounds: bounds asCPointer.
			bounds setY: ((bounds yCoord) + (bounds height) - 10.0).
			bounds setHeight: 10.0.

			((bounds mouseIn: (newP id) flipped: NO) == YES)
				ifTrue: [ 
					" 
					|  Reget the location and convert the point to 
					|  be in our superview then move ourself to that
					|  point within the view 
					"
					e location: (newP asCPointer).
					self convertPointToSuperview: (newP asCPointer).
					self moveBy: ((newP xCoord) - (p xCoord)) anArg: ((newP yCoord) - (p yCoord)). 
					((newP xCoord) - (p xCoord)) printNl.
					((newP yCoord) - (p yCoord)) printNl.
					self superview display. ]
				ifFalse: 
					[ endPoint setX: (newP xCoord) y: (newP yCoord).	self display ]. 
					
			p setX: (newP xCoord) ; setY: (newP yCoord) ] .
	
	e free.
	p free.
	newP free.
	bounds free.
	
	w flushWindow.
	w setEventMask: oldMask.

!!

"
| ============================================================================
"

STAppDelegate subclass: #Controller
		 instanceVariableNames: 'menu app window view subView'
		 classVariableNames: ''
		 poolDictionaries: ''
		 category: nil
!

!Controller methodsFor: 'App Delegation'!

appDidInit: arg0
	self initMenu.
	self initWindow.
	self initView.
!!

!Controller methodsFor: 'UI'!

initMenu
	| menuItem |
	menu := Menu alloc initTitle: 'View Test'.
	
	menu addItem: 'Info' action: nil keyEquivalent: nil.
	menu addItem: 'Print...' action: (OCInterface getUid: 'printPS:') keyEquivalent: ($p asciiValue).
	menu addItem: 'Hide' action: (OCInterface getUid: 'hide:') keyEquivalent: ($h asciiValue).
	menu addItem: 'Quit' action: (OCInterface getUid: 'terminate:') keyEquivalent: ($q asciiValue).	
	
	(Application new) setMainMenu: menu id.
!

initWindow
	| rect |
	rect := Rect alloc initFromX: 500.0 y: 600.0 width: 400.0 height: 200.0.
	window := Window alloc initContent: (rect asCPointer)
				style: 6
				backing: 2
				buttonMask: (4 bitOr: 1)
				defer: YES.
	window setTitle: 'View Test'.
!

initView
	| rect |
	rect := Rect alloc initFromX: 500.0 y: 600.0 width: 400.0 height: 200.0.
	view := SimpleView alloc initFrame: (rect asCPointer).
	
	rect setX: 50.0 ; setY: 50.0 ; setWidth: 200 ; setHeight: 50.
	subView := SimpleView alloc initFrame: (rect asCPointer).
	view addSubview: subView id.
	
	window setContentView: view id.
	window makeKeyAndOrderFront: nil.
	view display.
!!

"
| ============================================================================
"

!Object class methodsFor: 'main'!

main
	| app controller |
	app _ Application new.
	controller := Controller alloc init.
	app setDelegate: controller id.
	app run.
!!

Object main !