"======================================================================
|
|   X Atom class
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     26 Oct 90	  Began rehacking.
|
| sbyrne     24 May 90	  created.
|
"

XServerObject subclass: #Atom
	  instanceVariableNames: ''
	  classVariableNames: 'AtomNames'
	  poolDictionaries: ''
	  category: 'X Objects'
!

Atom comment: '###No comment yet'!


!Atom class methodsFor: 'initialization'!

initialize
    | names i |
    AtomNames _ Dictionary new.
    names _ #(Primary Secondary Arc Atom Bitmap Cardinal Colormap Cursor CutBuffer0
		  CutBuffer1 CutBuffer2 CutBuffer3 CutBuffer4 CutBuffer5 CutBuffer6
		  CutBuffer7 Drawable Font Integer Pixmap Point Rectangle ResourceManager
		  RGBColorMap RGBBestMap RGBBlueMap RGBDefaultMap RGBGrayMap RGBGreenMap
		  RGBRedMap String Visualid Window WmCommand WmHints WmClientMachine
		  WmIconName WmIconSize WmName WmNormalHints WmSizeHints WmZoomHints
		  MemSpace NormSpace MaxSpace EndSpace SuperscriptX SuperscriptY
		  SubstriptX SubscriptY UnderlinePosition UnderlineThickness
		  StrikeoutAscent StrikeoutDescent ItalicAngle XHeight QuadWidth
		  Weight PointSize Resolution Copyright Notice FontName FamilyName
		  FullName CapHeight WmClass WmTransientFor).
    i _ 1.
    names do: 
	[ :name | AtomNames at: name put: i.
		  i _ i + 1 ].
!

prop: propName on: aServer
    ^self new prop: propName on: aServer
! !



!Atom class methodsFor: 'X protocol requests'!

internAtom: name onlyIfExists: onlyIfExists onServer: server
    | req atom |
    req _ XRequest command: 16
		   aux: (XProtocol mapBool: onlyIfExists).
    req uword: (name size); uword: 0; string: name.
    req queueOn: server.
    
    server getReply.
    atom _ Atom maybeIdFrom: server symbols: #(None).
    server skip: 20.
    ^InternAtomReply atom: atom
! !



!Atom methodsFor: 'X protocol requests'!

getAtomName
    | req len name |
    req _ XRequest fixedCommand: 17.
    req ulong: id.
    req queueOn: server.
    
    server getReply.
    len _ server uword.
    server skip: 22.
    name _ server getString: len.    
    server skipPad.
    ^GetAtomNameReply name: name
! !


!Atom methodsFor: 'private'!

prop: propName on: aServer
    server _ aServer.
    id _ AtomNames at: propName
! !


Atom initialize!

LoadStatus _ 'Atom'!

