"======================================================================
|
|   2 byte Character Method Definitions
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
 ======================================================================"


"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"


"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      7 Dec 91	  Created from Character.
|			  'A date which will live in infamy'
|
"


"*** Having this be variable seems wrong ***"
Magnitude subclass: #Char2B
	  instanceVariableNames: 'byte1 byte2'
	  classVariableNames: ''
	  poolDictionaries: ''
	  category: nil
!

Char2B comment: 
'My instances represent the 256 characters of the character set.  I provide
messages to translate between integers and character objects, and provide
names for some of the common unprintable characters.' !


!Char2B class methodsFor: 'instance creation'!

byte1: byte1Val byte2: byte2Val
    ^self new byte1: byte1Val byte2: byte2Val
! !



!Char2B methodsFor: 'comparing'!

< aChar2B
    ^(byte1 < aChar2B byte1)
	or: [ (byte1 == aChar2B byte1) and: [ byte2 < aChar2B byte2 ] ]
!

<= aChar2B
    ^(self > aChar2B) not
!

> aChar2B
    ^(byte1 > aChar2B byte1)
	or: [ (byte1 == aChar2B byte1) and: [ byte2 > aChar2B byte2 ] ]
!

>= aChar2B
    ^(self < aChar2B) not
! !



!Char2B methodsFor: 'accessing'!

byte1
    ^byte1
!

byte2
    ^byte2
!

byte1: byte1Val byte2: byte2Val
    byte1 _ byte1Val.
    byte2 _ byte2Val
! !



!Char2B methodsFor: 'Coercion methods' "heh heh heh --  ve have vays..."!

asLowercase
    "I don't know what this means for 2 byte chars"
    ^self
!

asUppercase
    "I don't know what this means for 2 byte chars"
    ^self
! !



!Char2B methodsFor: 'printing'!

printOn: aStream
    aStream nextPut: ${;
	print: byte1;
	nextPut: $,;
	print: byte2;
	nextPut: $}; nl.
! !


"Inherit storing"
