"======================================================================
|
|   A simple class for shapes which can draw themselves and do hit detection.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
|
"
 

Object subclass: #Shape
       instanceVariableNames: 'gc rect'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
! 


!Shape class methodsFor: 'instance creation'!

new: gc bounds: aRect
    ^super new init: gc bounds: aRect
! !


!Shape methodsFor: 'rendering'!

drawOn: drawable
    "Default: draw a filled rectangle"
    drawable polyFillRectangle: gc
	     rectangles: (Array with: rect).
!

eraseFrom: drawable
    | agc whitePixel |
    whitePixel _ (drawable server root screens at: 1) whitePixel.
    agc _ GC createGC: drawable onServer: drawable server 
	    args: [ :r | r foreground: whitePixel ].
    drawable polyFillRectangle: agc
	     rectangles: (Array with: rect).
    agc freeGC
! !


!Shape methodsFor: 'testing'!

containsPoint: aPoint
    ^rect containsPoint: aPoint
! !


!Shape methodsFor: 'private'!

init: aGC bounds: aRect
    gc _ aGC.
    rect _ aRect
! !



Shape subclass: #Circle
      instanceVariableNames: ''
      classVariableNames: ''
      poolDictionaries: ''
      category: nil
!

!Circle methodsFor: 'drawing'!

drawOn: drawable
    | arc | 
    arc _ Arc x: rect left y: rect top
	      width: rect width height: rect height
	      angle1: 0
	      angle2: 64 * 360.
    drawable polyFillArc: gc
	     arcs: (Array with: arc).

! !


Shape subclass: #Triangle
      instanceVariableNames: ''
      classVariableNames: ''
      poolDictionaries: ''
      category: nil
! 


!Triangle methodsFor: 'rendering'!

drawOn: drawable
    | points |
    points _ Array 
	with: (rect bottomLeft)
	with: (rect bottomRight)
	with: (rect topCenter).
    drawable fillPoly: gc
	     shape: #Convex
	     coordinateMode: #Origin
	     points:  points
! !
