"======================================================================
|
|   Experimental STIX based GUI widget.
|
|   $Revision: 1.4 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	      1 Oct 94	  Fixed createPixmap call to not use onServer:
|			  selector.
|
| sbb	     16 Feb 92	  created around christmas 91.
|
"
Window subclass: #Widget
       instanceVariableNames: 'notify notifyVal'
       classVariableNames: 'GrayPixmap StripePixmap'
       poolDictionaries: ''
       category: 'Browsing experimental'
!

!Widget class methodsFor: 'common accessors'!

initialize
    GrayPixmap _ nil.
    StripePixmap _ nil.
!

grayPix: server
    | bits str pgc rootWin screen height |
    " This isn't quite right -- should be by server "
    GrayPixmap isNil ifTrue:
	[
	  GrayPixmap _ self pximapFromBits:
	      #(
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
		   2r0101010101010101
		   2r1010101010101010
	       ) server: server.
	 ].
    ^GrayPixmap
! 

stripePix: server
    | bits str pgc rootWin screen |
    " This isn't quite right -- should be by server "
    StripePixmap isNil ifTrue:
	[ StripePixmap _ self pixmapFromBits: 
	      #(
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
		    2r0101000001010101
		    2r1010100000101010
"
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010
		    2r0101010000010101
		    2r1010101000001010"
		    ) server: server.
	  ].
    ^StripePixmap
! !

!Widget class methodsFor: 'private'!

pixmapFromBits: bits server: server
    | str pgc rootWin screen bits8 pix height |
    str _ WriteStream on: #(ByteArray new: 0).
    Bigendian 
	ifTrue:
	    [ bits do: [ :word | str nextPut: 0; nextPut: 0;
			   nextPut: word // 256;
			   nextPut: (word bitAnd: 255). ] ]
	ifFalse: 
	    [ bits do: [ :word | str nextPut: 0; 
				     nextPut: 0;
				     nextPut: (word bitAnd: 255); 
				     nextPut: word // 256
				 ] ].

    bits8 _ str contents.
    height _ bits8 size // 4.
    screen _ (server root screens at: 1).
    rootWin _ screen window.
    pix _ Pixmap createPixmap: rootWin depth: screen rootDepth
		 width: 16 height: height.
		 

    pgc _ GC createGC: pix onServer: server args: nil.

    pix putImage: pgc depth: 1 width: 16 height: height
	dstX: 0 dstY: 0
	leftPad: 16 format: #Bitmap data: bits8.
    ^pix
! !
