"======================================================================
|
|   XGCRequest operation parameter definitions.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     18 Nov 90	  Created.
|
"
XRequest subclass: #XGCRequest
	 instanceVariableNames: ''
	 classVariableNames: ''
	 poolDictionaries: ''
	 category: 'X request container'!

XGCRequest comment: '###No comment yet'!



!XGCRequest class methodsFor: 'instance creation'!

command: aByte aux: aByte2
    ^self new init: aByte aux: aByte2
! !



!XGCRequest methodsFor: 'X variable flags'!

queueOn: aServer
    | length |
    "### Re-factor this and parent queueOn: method"
    self pad.
    self emitBitValues: false.
    length _ stream position // 4.
    stream position: 3.
    self word: length.
    ^aServer queueRequest: stream contents
! !



!XGCRequest methodsFor: 'X request users'!

function: aValue
    self at: 1 
	 ubyte: (XProtocol map: aValue
			   into: #(Clear And AndReverse Copy AndInverted
				       NoOp Xor Or Nor Equiv Invert
				       OrReverse CopyInverted OrInverted
				       Nand Set))
!
    
planeMask: aValue
    self at: 2 ulong: aValue
!

foreground: aValue
    self at: 3 ulong: aValue
!

background: aValue
    self at: 4 ulong: aValue
!

lineWidth: aValue
    self at: 5 uword: aValue
!

lineStyle: aValue
    self at: 6 ubyte: (XProtocol map: aValue 
				into: #(Solid OnOffDash DoubleDash))
!

capStyle: aValue
    self at: 7 ubyte: (XProtocol map: aValue 
				 into: #(NotLast Butt Round Projecting
				     "I love the ordering of the last three
				      style names...sounds descriptive"))
!

joinStyle: aValue
    self at: 8 ubyte: (XProtocol map: aValue into: #(Miter Round Bevel))
!

fillStyle: aValue
    self at: 9 ubyte: (XProtocol map: aValue
				 into: #(Solid Tiled Stippled OpaqueStippled))
!

fillRule: aValue
    self at: 10 ubyte: (XProtocol map: aValue
				  into: #(NotLast Butt Round Projecting))
!

tile: aValue
    self at: 11 ulong: aValue id
!

stipple: aValue
    self at: 12 ulong: aValue id
!

tileStippleXOrigin: aValue
    self at: 13 word: aValue
!

tileStippleYOrigin: aValue
    self at: 14 word: aValue
!

font: aValue
    self at: 15 ulong: aValue id
!

subwindowMode: aValue
    self at: 16 ubyte: (XProtocol map: aValue 
				  into: #(ClipByChildren IncludeInferiors))
!

graphicsExposures: aValue
    self at: 17 bool: aValue
!

clipXOrigin: aValue
    self at: 18 word: aValue
!

clipYOrigin: aValue
    self at: 19 word: aValue
!


clipMask: aValue
    self at: 20 ulong: (XProtocol maybeMap: aValue id into: #(None))
!

dashOffset: aValue
    self at: 21 uword: aValue
!

dashes: aValue
    self at: 22 ubyte: aValue
!

arcMode: aValue
    self at: 23 byte: (X map: aValue into: #(Chord PieSlice))
! !


!XGCRequest methodsFor: 'local initialization'!

localInit
    values _ Array new: 32	"large enough"
! !

LoadStatus _ 'XGCRequest'!
