"======================================================================
|
|   XKeyboardRequest operation parameter definitions.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"

"======================================================================
|
| Copyright (C) 1990, 1991, 1992, 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     18 Nov 90	  Created, during ""Hamlet"".
|
"
XRequest subclass: #XKeyboardRequest
	 instanceVariableNames: ''
	 classVariableNames: ''
	 poolDictionaries: ''
	 category: 'X request container'!

XKeyboardRequest comment: '###No comment yet'!


!XKeyboardRequest class methodsFor: 'instance creation'!

command: aByte aux: aByte2
    ^self new init: aByte aux: aByte2
! !



!XKeyboardRequest methodsFor: 'bit setting'!

keyClickPercent: percent
    self at: 1 byte: percent
!

bellPercent: percent
    self at: 2 byte: percent
!

bellPitch: pitch
    self at: 3 word: pitch
!

bellDuration: duration
    self at: 4 word: duration
!

led: ledIndex
    self at: 5 ubyte: ledIndex
!

ledMode: mode
    self at: 6 ubyte: (XProtocol map: mode into: #(Off On))
!

key: aKey
    self at: 7 ubyte: aKey
!

autoRepeatMode: mode
    self at: 8 ubyte: (XProtocol map: mode into: #(Off On Default))
! !

!XKeyboardRequest methodsFor: 'X variable flags'!

queueOn: aServer
    | length |
    "### Re-factor this and parent queueOn: method"
    self pad.
    self emitBitValues: false.
    length _ stream position // 4.
    stream position: 3.
    self word: length.
    ^aServer queueRequest: stream contents
! !

!XKeyboardRequest methodsFor: 'local initialization'!

localInit
    values _ Array new: 32	"large enough"
! !


LoadStatus _ 'XKeyboardRequest'!
