"======================================================================
|
|   Draws some cool looking color fountains.
|   Create one, and then call drawOn: with a drawable.
|   thermo.st contains an example of usage.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
"

X subclass: #Fountain 
       instanceVariableNames: 'startRGB deltaRGB numColors'
       classVariableNames: ''
       poolDictionaries: ''
       category: nil
!

!RGB methodsFor: 'arithmetic'!

+ otherRGB
     ^RGB red: red + otherRGB red
	  green: green + otherRGB green
	  blue: blue + otherRGB blue
!

- otherRGB
     ^RGB red: red - otherRGB red
	  green: green - otherRGB green
	  blue: blue - otherRGB blue.
!

* scalar
    ^RGB red: red * scalar
	 green: green * scalar
	 blue: blue * scalar
!

// scalar
    ^RGB red: red // scalar
	 green: green // scalar
	 blue: blue // scalar
! !


!Fountain methodsFor: 'drawing'!

drawOn: drawable
    | cmap screen allocation colors item r g b geom width height chunk rect 
      pixels | 
    screen _ drawable server root screens at: 1.
    cmap _ screen defaultColormap.
    
    allocation _ cmap allocColorCells: numColors planes: 0 contiguous: false.
    pixels _ allocation pixels.

    colors _ Array new: numColors.
    1 to: numColors do: 
	[ :i | r _ startRGB red + ((i * deltaRGB red) // numColors).
	       g _ startRGB green + ((i * deltaRGB green) // numColors).
	       b _ startRGB blue  + ((i * deltaRGB blue) // numColors).
	       
	       item _ ColorItem pixel: (pixels at: i)
			       doRed: true doGreen: true doBlue: true
			       red: r green: g blue: b.

	       colors at: i put: item ].

    cmap storeColors: colors.

    geom _ drawable getGeometry.
    width _ geom width.
    height _ geom height.
    chunk _ height // numColors.

    GC withGC: drawable
       args: nil
       do: [ :gc | 1 to: numColors do:
		       [ :i | gc changeGC: 
				  [ :r | r foreground:  (pixels at: i) ].
			      rect _ 0@(i - 1 * chunk) 
				  corner: width @ (i * chunk).
			      drawable polyFillRectangle: gc
				       rectangles: (Array with: rect).
			      ].
		   ].
    cmap freeColors: pixels planeMask: 0.
! 

"
newdrawOn: drawable
    | cmap screen allocation colors item r g b geom width height chunk rect 
      pixels | 
    screen _ drawable server root screens at: 1.
    cmap _ screen defaultColormap.
    
    allocation _ cmap allocColorCells: numColors planes: 0 contiguous: false.
    pixels _ allocation pixels.

    colors _ Array new: numColors.
    1 to: numColors do: 
	[ :i | r _ startRGB red + ((i * deltaRGB red) // numColors).
	       g _ startRGB green + ((i * deltaRGB green) // numColors).
	       b _ startRGB blue  + ((i * deltaRGB blue) // numColors).
	       
	       item _ ColorItem pixel: (pixels at: i)
			       doRed: true doGreen: true doBlue: true
			       red: r green: g blue: b.

	       colors at: i put: item ].

    cmap storeColors: colors.

    geom _ drawable getGeometry.
    width _ geom width.
    height _ geom height.
    chunk _ height // numColors.

    GC withGC: drawable
       args: nil
       do: [ :gc | 1 to: numColors do:
		       [ :i | gc changeGC: 
				  [ :r | r foreground:  (pixels at: i) ].
			      drawBlock value: i value: gc value: drawable.
			      ].
		   ].
    cmap freeColors: pixels planeMask: 0.
!" !


!Fountain class methodsFor: 'instance creation'!

start: start end: end
    ^self new init: start end: end

! !


!Fountain methodsFor: 'private'!

init: start end: end
    startRGB _ start.
    deltaRGB _ end - start.
    numColors _ 50.
! !
