"======================================================================
|
|   Keyboard event decoding example.
|
|   $Revision: 1.3 $
|   $Date: 1995/06/06 14:56:15 $
|   $Author: sbb $
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 1994, 1995 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 1, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
|
 ======================================================================"

"
|     Change Log
| ============================================================================
| Author       Date       Change 
| sbb	     28 Aug 94	  Added header stuff.
|
"

X subclass: #Keys
       instanceVariableNames: 'mapping minKey maxKey'
       classVariableNames: 'window'
       poolDictionaries: ''
       category: nil
! 

FileStream fileIn: 'WinEvents.st'!


!Keys class methodsFor: 'instance creation'!

new
    ^super new init
! !


!Keys methodsFor: 'event handling'!

run
    window server processEvents.
!

stopRunning
    window server close.
    ExitHandlerLoop _ true.
! 

handleButtonPress: event
    event detail == 3
	ifTrue: [ self stopRunning ].
    
! 

handleKeyPress: event
    | key index keysymsPer chInt ch |
    key _ event detail.
   " event inspect."
    keysymsPer _ mapping keysymsPerKeycode.
    index _ (key - minKey) * keysymsPer + 1. "0 based -> 1 based"
  "  'state is ' print. event state printNl."
    (event state allMask: 1)	"is it shifted?"
	ifTrue: [ chInt _ mapping keysyms at: index + 1.
		  chInt == 0
		      ifTrue: [ "oops, no special shifted version"
				chInt _ mapping keysyms at: index. ].
		  ]
	ifFalse: [ chInt _ mapping keysyms at: index. ].
    (chInt between: 0  and: 126)
	ifTrue: [ "event state printNl."
		  (event state allMask: 4) "control"
		      ifTrue: 
			  [ (chInt between: $@ asciiValue 
				  and: $_ asciiValue)
				ifTrue: [ chInt _ chInt bitXor: 64 ].
			    ].
		  (event state noMask: 1) "unshifted"
		      ifTrue: [ (chInt between: $A asciiValue 
				       and: $Z asciiValue)
				    ifTrue: [ chInt _ chInt + 32 ] ].
		  ch _ Character value: chInt.
		  stdout nextPut: ch; nl.
		  index to: index + keysymsPer - 1 do:
		       [ :i | stdout print: i; space; print: (mapping keysyms at: i); nl ].

		  ]
	ifFalse: [ index to: index + keysymsPer - 1 do:
		       [ :i | stdout print: i; space; print: (mapping keysyms at: i); nl ] ].

    
! !



!Keys methodsFor: 'private'!

init
    | s root screen rootWin cmap |
    window notNil
	ifTrue: [ window server close.
		  " ### Very clumsy "
		  EventHandlers _ Dictionary new. ].
    s _ Server connectToDisplay.
    root _ s root.
    screen _ root screens at: 1.
    rootWin _ screen window.

    minKey _ root minKeycode.
    maxKey _ root maxKeycode.
    mapping _ s getKeyboardMapping: minKey count: maxKey - minKey + 1.

    window _ Window createWindow: rootWin class: #CopyFromParent
		    depth: 0
		    visual: #CopyFromParent x: 0 y: 0
		    width: 400 height: 400
		    borderWidth: 1 onServer: s
		    attrs: [ :r | r eventMask: #(Exposure
						     ButtonPress
						     KeyPress
						     );
				      backingStore: #Always ].

    
    self registerEventHandlers.    
    window mapWindow.


!

registerEventHandlers
    window registerFor: ExposeEvent
	   when: [ :e | e window == window id ]
	   do: [ :e | e count = 0 
			  ifTrue: [ 'exposed' printNl ] ].
    window registerFor: NoExposureEvent
	   when: [ :e | true ]
	   do: [ :e | ].
    window registerFor: ButtonPressEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleButtonPress: e ].
    
    window registerFor: KeyPressEvent
	   when: [ :e | e event == window id ]
	   do: [ :e | self handleKeyPress: e ].
    
!  !

"

| k | 
    k _ Keys new.
    k run.
!
"
