(* Copyright (C) 1992, Digital Equipment Corporation                         *)
(* All rights reserved.                                                      *)
(* See the file COPYRIGHT for a full description.                            *)
(*                                                                           *)
(* Last modified on Tue Nov 23 16:40:07 PST 1993 by kalsow                   *)
(*      modified on Fri May  7 17:17:14 PDT 1993 by muller                   *)

INTERFACE DragonT;

IMPORT DragonInt, Ctypes;

(* This interface implements the Dragon routine to print floating point
   numbers, as described in:

        "How to Print Floating-Point Numbers Accurately",
        Guy L. Steele Jr. and Jon L. White, 
        Proceedings of the ACM Sigplan'90 conference on Programming 
        Language Design and Implementation, 
        pp 112-126. *)


TYPE 
  CutoffMode = {normal, absolute, relative};
  Digit = [0 .. 9];

PROCEDURE F (e: INTEGER; READONLY f: DragonInt.T;  p: INTEGER;
             cutoffMode: CutoffMode;
             cutoffPlace: INTEGER;
             VAR digits: ARRAY OF Digit;
             VAR count: CARDINAL;
             VAR exp: INTEGER);

(* See the article mentionned above for a description of this procedure.

   The interface DragonSplit provides routines to convert a REAL,
   LONGREAL or EXTENDED to the inputs needed by this procedure. *)


<*EXTERNAL strtod*>
PROCEDURE strtod (nptr: Ctypes.char_star; 
                  eptr: Ctypes.char_star_star): LONGREAL;

END DragonT.
