(* Copyright (C) 1990, Digital Equipment Corporation           *)
(* All rights reserved.                                        *)
(* See the file COPYRIGHT for a full description.              *)
(* Last modified on Wed Sep 29 09:16:23 PDT 1993 by kalsow     *)
(*      modified on Wed Mar 13 01:21:53 1991 by muller         *)

INTERFACE RTProcess;

(* This interface provides the runtime shutdown routines. *)

PROCEDURE RegisterExitor (p: PROCEDURE ());
(* Registers the procedure p to be executed when Exit is called.
   The registered procedures are executed in reverse of the order
   they were registered. *)

PROCEDURE Exit (n: INTEGER);
(* call the registered exitors and terminate the program with status "n".
   Terminating a Modula-3 program by ``falling off the end'' is like
   calling "Exit(0)".*)

PROCEDURE Crash (msg: TEXT);
(* Call the registered exitors and terminate the program with the
   error message "msg".  If possible, invoke a debugger or generate a
   core dump. *)

PROCEDURE InvokeExitors ();
(* Run the registered exit procedures, at most once. *)

END RTProcess.

